package org.netkernel.lang.ncode.builtin;

import org.netkernel.container.IMessages;
import org.netkernel.layer0.meta.IEndpointMeta;
import org.netkernel.layer0.meta.IIdentifierGrammar;
import org.netkernel.layer0.meta.impl.EndpointMetaBuilder;
import org.netkernel.layer0.meta.impl.MetadataUtils;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.urii.ParsedIdentifierImpl;
import org.netkernel.layer0.util.OrderedCheapMultiStringMap;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.w3c.dom.Document;

public class IdentifierBuilderAccessor extends StandardAccessorImpl
{
	public IdentifierBuilderAccessor()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{	
		IMessages messages=aContext.getKernelContext().getKernel().getLogger();
		Document grammarDoc=(Document)aContext.source("arg:grammar", Document.class);
		EndpointMetaBuilder epm=new EndpointMetaBuilder();
		MetadataUtils.parseGrammar(grammarDoc.getDocumentElement(), epm, messages);
		IEndpointMeta meta=epm.getMeta(messages);
		IIdentifierGrammar grammar=meta.getIdentifierGrammar();

		INKFRequestReadOnly thisReq=aContext.getThisRequest();
		int argCount=thisReq.getArgumentCount();
		OrderedCheapMultiStringMap parts=new OrderedCheapMultiStringMap(argCount);
		for (int i=0; i<argCount; i++)
		{	String argName=thisReq.getArgumentName(i);
			if (argName.equals("grammar") || argName.equals(ParsedIdentifierImpl.ARG_ACTIVE_SCHEME) || argName.equals(ParsedIdentifierImpl.ARG_ACTIVE_TYPE)) continue;
			parts.put(argName, aContext.source("arg:"+argName,String.class));
		}
		
		String identifier=grammar.construct(parts, messages);
		aContext.createResponseFrom(identifier);
	}
}