package org.netkernel.lang.ncode.builtin;

import org.netkernel.layer0.meta.impl.IdentifierArgumentMetaImpl;
import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.urii.SimpleIdentifierImpl;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.urii.IIdentifier;

public class NewVerbAccessor extends StandardAccessorImpl
{
	public NewVerbAccessor()
	{	declareThreadSafe();
		declareArgument(new IdentifierArgumentMetaImpl("identifier",null,null));
		declareArgument(new SourcedArgumentMetaImpl("representation",null,null,null));
		declareSourceRepresentation(IIdentifier.class);
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{	String identifier=aContext.getThisRequest().getArgumentValue("identifier");
		Object rep;
		if (aContext.getThisRequest().argumentExists("representation"))
		{	rep=aContext.source("arg:representation");
		}
		else
		{	rep=null;
		}
		String newIdentifier=aContext.requestNew(identifier, rep);
		aContext.createResponseFrom(new SimpleIdentifierImpl(newIdentifier));
	}
}