package org.netkernel.lang.ncode.builtin;

import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.urii.ParsedIdentifierImpl;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class SequenceAccessor extends StandardAccessorImpl
{
	public SequenceAccessor()
	{	declareThreadSafe();
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{	INKFRequestReadOnly thisReq=aContext.getThisRequest();
		int argCount=thisReq.getArgumentCount();
		for (int i=0; i<argCount; i++)
		{	String argName=thisReq.getArgumentName(i);
			if (!argName.equals(ParsedIdentifierImpl.ARG_ACTIVE_SCHEME) && !argName.equals(ParsedIdentifierImpl.ARG_ACTIVE_TYPE))
			{	String argValue=thisReq.getArgumentValue(i);
				INKFResponseReadOnly respIn=aContext.sourceForResponse(argValue);
				if (argName.equals("response"))
				{	aContext.createResponseFrom(respIn);
				}
			}
		}
	}
}