package org.netkernel.lang.ncode.builtin;

import org.netkernel.layer0.meta.impl.IdentifierArgumentMetaImpl;
import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;
import org.netkernel.layer0.util.RequestScopeClassLoader;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class TransreptVerbAccessor extends StandardAccessorImpl
{
	public TransreptVerbAccessor()
	{	declareThreadSafe();
		declareArgument(new SourcedArgumentMetaImpl("operand",null,null,new Class[] {Object.class}));
		declareArgument(new SourcedArgumentMetaImpl("to",null,null,new Class[] {String.class}));
		declareSourceRepresentation(Void.class);
	}
	
	public void onSource(INKFRequestContext aContext) throws Exception
	{	String required=aContext.source("arg:to",String.class);
		RequestScopeClassLoader cl=new RequestScopeClassLoader(aContext.getKernelContext().getRequestScope());
		Class requiredClass=cl.loadClass(required);
		INKFResponseReadOnly respIn=aContext.sourceForResponse("arg:operand",requiredClass);
		aContext.createResponseFrom(respIn);
	}	
}