var gUndoHistory = new Array();
var gRedoHistory = new Array();
var gInAction=false;
var gInActionDo=false;
var gChangesLatch=false;
var gActionCount=0;
var gHistoryLength=50;
var gAutosave=false;

function initialiseToolbar()
{
	$("#tbicon-save").click(onClickSave);
	$("#tbicon-settings").click(onEditSettings);
	$("#tbicon-help").click(function()
	{	showDocumentation(null,"doc:lang:ncode:ui");
	});
	var fsIcon=$("#tbicon-fullscreen");
	if (location.href.indexOf("physicalDetails")>0)
	{	fsIcon.click( function()
		{	location.href="/tools/ncode/edit/"+gEntityId;
		});
	}
	else
	{	fsIcon.attr("title","restore").attr("id","tbicon-restore").click( function()
		{	location.href="/tools/ae/view/physicalDetails/"+gEntityId;
		});
	}
}

function onClickSave()
{	if (gActionCount!=0)
	{	onSave();
	}
	else
	{	//toggle autosave
		gAutosave=!gAutosave;
		updateUndoUI();
	}
}

function doAction(aAction,aForce)
{	
	if (gAjaxBusy && !aForce)
	{	return;
	}

	if (gUndoHistory.length==gHistoryLength)
	{	gUndoHistory.shift();
	}
	gUndoHistory.push(aAction);
	gRedoHistory.length=0;
	gActionCount++;
	updateUndoUI();
	gInAction=true;
	gInActionDo=true;
	aAction.doAction();
	gInAction=false;
	gInActionDo=false;
}

function undoAction()
{
	if (gAjaxBusy)
	{	return;
	}
	
	deselect();
	action=gUndoHistory.pop();
	gRedoHistory.push(action);
	gActionCount--;
	updateUndoUI();
	gInAction=true;
	action.undoAction();
	gInAction=false;
}

function redoAction()
{
	if (gAjaxBusy)
	{	return;
	}
	
	deselect();
	action=gRedoHistory.pop();
	gUndoHistory.push(action);
	gActionCount++;
	updateUndoUI();
	gInAction=true;
	action.doAction();
	gInAction=false;
}

function resetAction()
{	
	gRedoHistory.length=0;
	gUndoHistory.length=0;
	gActionCount=0;
	updateUndoUI();
}

function updateUndoUI()
{
	var undoButton=$("#tbicon-undo");
	var undoCurrentlyEnabled=undoButton.hasClass("tbicon-enabled");
	var undoToEnable=gUndoHistory.length>0;
	if (undoToEnable && !undoCurrentlyEnabled)
	{	undoButton.addClass("tbicon-enabled");
		undoButton.click(undoAction);
	}
	if (!undoToEnable && undoCurrentlyEnabled)
	{	undoButton.removeClass("tbicon-enabled");
		undoButton.unbind("click");
	}
	
	var redoButton=$("#tbicon-redo");
	var redoCurrentlyEnabled=redoButton.hasClass("tbicon-enabled");
	var redoToEnable=gRedoHistory.length>0;
	if (redoToEnable && !redoCurrentlyEnabled)
	{	redoButton.addClass("tbicon-enabled");
		redoButton.click(redoAction);
	}
	if (!redoToEnable && redoCurrentlyEnabled)
	{	redoButton.removeClass("tbicon-enabled");
		redoButton.unbind("click");
	}	

	var saveButton=$("#tbicon-save");
	var saveCurrentlyEnabled=saveButton.hasClass("tbicon-enabled");
	var saveToEnable=gActionCount!=0;
	if (saveToEnable && !saveCurrentlyEnabled)
	{	saveButton.addClass("tbicon-enabled");
		//saveButton.click(onSave);
	}
	if (!saveToEnable && saveCurrentlyEnabled)
	{	saveButton.removeClass("tbicon-enabled");
		//saveButton.unbind("click");
	}
	//var autosaveCurrentlyEnabled=saveButton.hasClass("autosave");
	if (gAutosave)
	{	saveButton.addClass("autosave");
	}
	else
	{	saveButton.removeClass("autosave");
	}


}


//************************
// Action class
//************************
function Action()
{
}
 
Action.prototype.doAction = function()
{	
}
Action.prototype.undoAction = function()
{	
}

//************************
// CreateEndpointAction class
//************************
CreateEndpointAction.prototype = new Action;
function CreateEndpointAction(aEndpoint)
{	this.mEndpoint=aEndpoint;
}
 
CreateEndpointAction.prototype.doAction = function()
{	this.mEndpoint.onRestore();
	performValidationTasks();
}

CreateEndpointAction.prototype.undoAction = function()
{	this.mEndpoint.onDelete();
}

//************************
// DeleteEndpointAction class
//************************
DeleteEndpointAction.prototype = new Action;
function DeleteEndpointAction(aEndpoint)
{	this.mEndpoint=aEndpoint;
}
 
DeleteEndpointAction.prototype.doAction = function()
{	this.mEndpoint.onDelete();
	performValidationTasks();
}

DeleteEndpointAction.prototype.undoAction = function()
{	this.mEndpoint.onRestore();
	this.mEndpoint.canvasRedraw(true); //just in case 
	performValidationTasks();
}

//************************
// MoveEndpointAction class
//************************
MoveEndpointAction.prototype = new Action;
function MoveEndpointAction(aEndpoint, aOldTop, aOldLeft, aTop, aLeft)
{	this.mEndpoint=aEndpoint;
	this.mOldTop=aOldTop;
	this.mOldLeft=aOldLeft;
	this.mTop=aTop;
	this.mLeft=aLeft;
}
 
MoveEndpointAction.prototype.swap = function()
{	
	var left=this.mOldLeft;
	this.mOldLeft=this.mLeft;
	this.mLeft=left;
	
	var top=this.mOldTop;
	this.mOldTop=this.mTop;
	this.mTop=top;
		
	this.mEndpoint.updatePosition(left,top);
}
MoveEndpointAction.prototype.doAction = function()
{	deselect();
	this.swap();
}
MoveEndpointAction.prototype.undoAction = function()
{	deselect();
	this.swap();
}

//************************
// ResizeEndpointAction class
//************************
ResizeEndpointAction.prototype = new Action;
function ResizeEndpointAction(aEndpoint, aOldWidth, aOldHeight, aWidth, aHeight)
{	this.mEndpoint=aEndpoint;
	this.mOldWidth=aOldWidth;
	this.mOldHeight=aOldHeight;
	this.mWidth=aWidth;
	this.mHeight=aHeight;
}
ResizeEndpointAction.prototype.doAction = function()
{	this.mEndpoint.mWidth=this.mWidth;
	this.mEndpoint.mHeight=this.mHeight;
	this.mEndpoint.update();
}
ResizeEndpointAction.prototype.undoAction = function()
{	this.mEndpoint.mWidth=this.mOldWidth;
	this.mEndpoint.mHeight=this.mOldHeight;
	this.mEndpoint.update();
}

//************************
// SetEndpointValueAction class
//************************
SetEndpointValueAction.prototype = new Action;
function SetEndpointValueAction(aEndpoint, aValue)
{	this.mEndpoint=aEndpoint;
	this.mValue=aValue;
	this.mPreviousValue=this.mEndpoint.mValue?this.mEndpoint.mValue:"";
}
SetEndpointValueAction.prototype.doAction = function()
{	this.mEndpoint.setValue(this.mValue);
}
SetEndpointValueAction.prototype.undoAction = function()
{	this.mEndpoint.setValue(this.mPreviousValue);
}

//************************
// CreateWireAction class
//************************
CreateWireAction.prototype = new Action;
function CreateWireAction(aFromConnector, aToConnector)
{	this.mFromConnector=aFromConnector
	this.mToConnector=aToConnector;
}

CreateWireAction.prototype.doAction = function()
{	
	//remove existing input wire
	if (this.mToConnector.mType==EpConnector.prototype.ARG && this.mToConnector.mWires.length>0)
	{	this.mRemovedWire = this.mToConnector.mWires[0];
		this.mRemovedWire.destroy();
	}	

	if (!this.mWire)
	{	
		this.mWire=new Wire(this.mFromConnector,this.mToConnector);
		this.mWire.restore();
	}
	else
	{	this.mWire.restore();
	}
	this.mWire.update();
	performValidationTasks();
}
CreateWireAction.prototype.undoAction = function()
{	this.mWire.destroy();
	if (this.mRemovedWire)
	{	this.mRemovedWire.restore();
		this.mRemovedWire.update();
	}
	performValidationTasks();
}


//************************
// DeleteWireAction class
//************************
DeleteWireAction.prototype = new Action;
function DeleteWireAction(aWire)
{	this.mWire=aWire;
	var endC=aWire.endC;
	this.mEndCProto=endC.mParent.getInput(endC.mIndex).p;
	this.mEndCName=endC.mName;
	this.mEndCIndex=endC.mIndex;
}
 
DeleteWireAction.prototype.doAction = function()
{	this.mWire.destroy();
	performValidationTasks();
}

DeleteWireAction.prototype.undoAction = function()
{	
	var oldEndC=this.mWire.endC;
	var endE=oldEndC.mParent;
	var endC=endE.undoWireDelete(this.mEndCIndex,this.mEndCProto,this.mEndCName);
	this.mWire.endC=endC;
	
	this.mWire.restore();
	performValidationTasks();
}


//************************
// UpdatePropertiesAction class
//************************
UpdatePropertiesAction.prototype = new Action;
function UpdatePropertiesAction(aFlow,aId,aName,aDesc,aIsPublic,aVerbs,aGrammar,aInputs)
{	
	this.mFlow=aFlow;
	this.mOldId=aFlow.getEndpointId();
	this.mOldName=aFlow.getName();
	this.mOldDesc=aFlow.getDesc();
	this.mOldIsPublic=aFlow.isPublic();
	this.mOldVerbs=aFlow.getVerbs();
	this.mOldGrammar=aFlow.getGrammar();
	this.mOldInputs=aFlow.getInputs();
	this.mId=aId;
	this.mName=aName;
	this.mDesc=aDesc;
	this.mIsPublic=aIsPublic;
	this.mVerbs=aVerbs;
	this.mGrammar=aGrammar;
	this.mInputs=aInputs;
}
 
UpdatePropertiesAction.prototype.doAction = function()
{	var f=this.mFlow;
	f.mDefn.id=this.mId;
	f.mDefn.name=this.mName;
	f.mDefn.desc=this.mDesc;
	f.mDefn.isPublic=this.mIsPublic;
	f.mDefn.verbs=this.mVerbs;
	f.mDefn.grammar=this.mGrammar;
	f.mDefn.input=this.mInputs;
	renameTab(f.mId,this.mName);
	if (this.mGrammar!=this.mOldGrammar || this.mName!=this.mOldName)
	{	
		performTabSwitchInner(gCurrentFlow,gCurrentFlow);
	}
}

UpdatePropertiesAction.prototype.undoAction = function()
{	var f=this.mFlow;
	f.mDefn.id=this.mOldId;
	f.mDefn.name=this.mOldName;
	f.mDefn.desc=this.mOldDesc;
	f.mDefn.isPublic=this.mOldIsPublic;
	f.mDefn.verbs=this.mOldVerbs;
	f.mDefn.grammar=this.mOldGrammar;
	f.mDefn.input=this.mOldInputs;
	renameTab(f.mId,this.mOldName);
	if (this.mGrammar!=this.mOldGrammar)
	{	
		performTabSwitchInner(gCurrentFlow,gCurrentFlow);
	}
}

//************************
// CreateFlowAction class
//************************
CreateFlowAction.prototype = new Action;
function CreateFlowAction(aFlow)
{	this.mFlow=aFlow;
}
CreateFlowAction.prototype.doAction = function()
{	gFlows.push(this.mFlow);
	createTabFor(this.mFlow);
	syncTabSwitch();
}
CreateFlowAction.prototype.undoAction = function()
{	closeTab(this.mFlow);	
	syncTabSwitch();
}

//************************
// DeleteFlowAction class
//************************
DeleteFlowAction.prototype = new Action;
function DeleteFlowAction(aFlow)
{	this.mFlow=aFlow;
}
DeleteFlowAction.prototype.doAction = function()
{	closeTab(this.mFlow);
	syncTabSwitch();
}
DeleteFlowAction.prototype.undoAction = function()
{	gFlows.push(this.mFlow);
	createTabFor(this.mFlow);
	syncTabSwitch();
}

//************************
// SwitchFlowAction class
//************************
SwitchFlowAction.prototype = new Action;
function SwitchFlowAction(aPreviousFlow,aFlow)
{	this.mFlow=aFlow;
	this.mPreviousFlow=aPreviousFlow;
}
SwitchFlowAction.prototype.doAction = function()
{	if (gInActionDo)
	{	performTabSwitch(this.mFlow,this.mPreviousFlow,true);
	}
	else
	{	selectTabIfNecessary(this.mFlow);
	}
	syncTabSwitch();
}
SwitchFlowAction.prototype.undoAction = function()
{	selectTabIfNecessary(this.mPreviousFlow);
	syncTabSwitch();
}

//************************
// SetConnectorNameAction class
//************************
SetConnectorNameAction.prototype = new Action;
function SetConnectorNameAction(aConnector,aName,aOriginalName)
{	this.mConnector=aConnector;
	this.mName=aName;
	this.mOriginalName=aOriginalName;
}
SetConnectorNameAction.prototype.doAction = function()
{	
	if (this.mConnector.isOrphaned())
	{	this.mConnector=this.mConnector.getReplacement();
	}
	this.mConnector.setName(this.mName);
	this.mConnector.mParent.canvasRedraw(true);
}
SetConnectorNameAction.prototype.undoAction = function()
{	this.mConnector.setName(this.mOriginalName);
	this.mConnector.mParent.canvasRedraw(true);
}

//************************
// ChangeSettingsAction class
//************************
ChangeSettingsAction.prototype = new Action;
function ChangeSettingsAction(aAutosave,aHistoryLength,aDynamicImports)
{	this.mAutosave=aAutosave;
	this.mHistoryLength=aHistoryLength;
	this.mDynamicImports=aDynamicImports;
	
	this.mUndoAutosave = gAutosave;
	this.mUndoHistoryLength = gHistoryLength;
	if (this.mDynamicImports)
	{	this.mUndoDynamicImports = gDynamicImports;
	}
}
ChangeSettingsAction.prototype.doAction = function()
{	gAutosave=this.mAutosave;
	gHistoryLength=this.mHistoryLength;
	updateUndoUI();
	if (this.mDynamicImports)
	{	gDynamicImports=this.mDynamicImports;
		gImportsChanged=true;
		reloadPalette();
	}
}
ChangeSettingsAction.prototype.undoAction = function()
{	gAutosave=this.mUndoAutosave;
	gHistoryLength=this.mUndoHistoryLength;
	updateUndoUI();
	if (this.mUndoDynamicImports)
	{	gDynamicImports=this.mUndoDynamicImports;
		gImportsChanged=true;
		reloadPalette();
	}
}