//************************
// EpConnector class
//************************
EpConnector = function(aParent, aTop, aLeft, aType, aName, aIndex)
{
	this.mParent = aParent;
	this.mTop = aTop;
	this.mLeft = aLeft;
	this.mWires=new Array();
	this.mDragWire=null;
	this.mType=aType;
	this.mName=aName;
	this.mIndex=aIndex;
	
	this.mRep="java.lang.Object";
	this.mRenamable=false;
	this.mOptional=false;
	this.mOver=false;
	
	if (aType==EpConnector.prototype.ARG)
	{	this.mDirection=[-1,0];
	}
	else if (aType==EpConnector.prototype.RESPONSE)
	{	this.mDirection=[1,0];
	}
	else
	{	this.mDirection=[0,1.5];
	}
	
	var d = $("<div class='connector connector-ff'></div>");
	this.mRoot = d;
	/*
	if (this.mType==EpConnector.prototype.ARG)
	{	this.mLabel=$("<div class='connector-label'>"+this.mName+"</div>");
	}
	if (this.mType==EpConnector.prototype.INJECTED)
	{	this.mLabel=$("<div class='connector-label-injected'>"+this.mName+"</div>");
	}	
	*/
}

EpConnector.prototype.innerInit = function()
{	d=this.mRoot;
	d.appendTo(this.mParent.mRoot);
	if (this.mLabel)
	{	this.mLabel.appendTo(this.mParent.mRoot);
	}
	d.data("obj", this);
	
	d.draggable(
	{	helper: "clone",
	/*
		helper: function()
		{	var helper=$("#wireDragHelper");
			helper.css("display: block;");
			return helper.get(0);
		},*/ 
		containment: gEditCanvas,
		//revert: "invalid",
		zIndex: 5,
		opacity: 0.5, 
		cursor: "move",
		start: this.startDrag,
		drag: this.doDrag,
		stop: this.stopDrag
	});
	
	d.droppable(
	{	accept: "#nothing",
		tolerance: "pointer",
		over: this.dropOver,
		out: this.dropOut,
		drop: this.onDrop
	});
	
	this.updateProto();
	this.updatePosition();
}

EpConnector.prototype.update = function(aY, aIndex, aOptional, aName)
{	this.mTop=aY;
	this.mIndex=aIndex;
	this.mOptional=aOptional;
	this.setName(aName);

	this.updatePosition();
	this.updateProto();
}

EpConnector.prototype.updateProto = function()
{
	var defn=this.mParent.getInput(this.mIndex);
	this.mOptional=defn.o;
	//this.updateIcon(false,false);
	
	this.mRep=defn.t+" ("+defn.s+")";
	this.mRoot.attr("title", this.mRep);
	
	this.mRoot.unbind("dblclick");
	this.mRenamable=defn.r;
	if (defn.r)
	{	this.mRoot.dblclick(this.editName);
	}
}

EpConnector.prototype.onDelete = function(forceRemove)
{	
	if (forceRemove)
	{	this.mRoot.remove();
		if (this.mLabel)
		{	this.mLabel.remove();
		}
	}
	
	var wiresToDelete=new Array();
	for (var w in this.mWires)
	{	wiresToDelete.push(this.mWires[w]);
	}
	for (var w in wiresToDelete)
	{	wiresToDelete[w].destroy();
	}
	this.mWiresToRestore=wiresToDelete;
}

EpConnector.prototype.onRestore = function()
{
	for (var w in this.mWiresToRestore)
	{	this.mWiresToRestore[w].restore();
	}
	delete this.mWiresToRestore;
	this.updateIcon(false,false);
}

EpConnector.prototype.RESPONSE=0;
EpConnector.prototype.ARG=1;
EpConnector.prototype.INJECTED=2;

EpConnector.prototype.startDrag = function(e,ui)
{
	var connector=$(e.target).data("obj");	

	//mark an existing input as pending removal/replacement
	if (connector.mType==EpConnector.prototype.ARG && connector.mWires.length>0)
	{	var wireIn = connector.mWires[0];
		wireIn.setPending(true);
	}

	p=gEditCanvas.offset();
	x=ui.offset.left-p.left;
	y=ui.offset.top-p.top;
	connector.mDummyEnd = new DummyEpConnector(x,y);
	connector.mDragWire = new Wire(connector,connector.mDummyEnd);
	connector.mDragWire.innerInit();
	connector.updateIcon(false,true);

	connector.mValidEnds = connector.findValidEnds();
	//console.log(connector.mValidEnds);
	for (var i=0; i<connector.mValidEnds.length; i++)
	{	var endConnector = connector.mValidEnds[i];
		//endConnector.dd.addToGroup("validEnd");
		endConnector.updateIcon(true,false);
	}
}

EpConnector.prototype.doDrag = function(e,ui)
{
	//e.stopPropagation();
	connector=$(e.target).data("obj");	
	p=gEditCanvas.offset();
	x=ui.offset.left-p.left;
	y=ui.offset.top-p.top;
	connector.mDummyEnd.setPosition(x,y);
	connector.mDragWire.update();
}

EpConnector.prototype.stopDrag = function(e,ui)

{
	//console.log("stop drag");
	//unmark an existing input as pending removal/replacement
	if (connector.mType==EpConnector.prototype.ARG && connector.mWires.length>0)
	{	var wireIn = connector.mWires[0];
		wireIn.setPending(false);
	}
	
	connector=$(e.target).data("obj");
	connector.mDragWire.destroy();
	connector.mDragWire=null;
	connector.mDummyEnd=null;
	connector.updateIcon(false,false);
	
	for (var i=0; i<connector.mValidEnds.length; i++)
	{	var endConnector = connector.mValidEnds[i];
		//endConnector.dd.addToGroup("invalidEnd");
		//endConnector.dd.removeFromGroup("validEnd");
		endConnector.updateIcon(false,false);
	}
	connector.mValidEnds=null;
}

EpConnector.prototype.dropOver = function(e,ui)
{	//console.log("over");
	connector=$(e.target).data("obj");
	connector.updateIcon(true,true);

}	
EpConnector.prototype.dropOut = function(e,ui)
{	connector=$(e.target).data("obj");
	connector.updateIcon(true,false);
	//console.log("out");
}	

EpConnector.prototype.onDrop = function(e,ui)
{	//console.log("drop");
	$( this ).find( ".placeholder" ).remove();
	var connectorIn=$(e.target).data("obj");
	var connectorOut=ui.draggable.data("obj");
		
	//console.log(connectorOut);
	if (connectorIn.mType!=EpConnector.prototype.ARG)
	{	var c=connectorIn;
		connectorIn=connectorOut;
		connectorOut=c;
	}
	
	var action = new CreateWireAction(connectorOut, connectorIn);
	doAction(action);
}

EpConnector.prototype.isOrphaned = function()
{	return this.mParent.getConnectorWithId(this.mIndex)!=this;
}

EpConnector.prototype.getReplacement = function()
{	return this.mParent.getConnectorWithId(this.mIndex);
}

EpConnector.prototype.addWire = function(aWire)
{	
	//test to see if connector is still valid
	if (this.mParent.getConnectorWithId(this.mIndex)!=this)
	{	console.log("disconnect!");
	}	

	if (aWire!=this.mDragWire)
	{	this.mWires.push(aWire);
	}
	this.updateIcon(false,false);
}

EpConnector.prototype.removeWire = function(aWire)
{	removeFromArray(this.mWires,aWire);
	this.updateIcon(false,false);
}

EpConnector.prototype.updateIcon = function(aDropable, aOver)
{	
	if (this.mParent.mDeleted) return;
	
	if (aOver!=this.mOver)
	{	
		//console.log("connector force redraw "+this.mOver+"->"+aOver);
		this.mOver=aOver;
		this.mParent.canvasRedraw(true);
	}
	
	
	var className="connector-";
	//console.log(this.mWires);
	if (aOver || this.mDragWire!=null || this.mWires.length>0)
	{	className+="t";
	}
	else if (this.mOptional)
	{	className+="o";
	}
	else
	{	className+="f";
	}
	
	if (aDropable)
	{	className+="t";
		try
		{	this.mRoot.droppable( "option", "accept",  ".connector");
		} catch (e) { }
	}
	else
	{	className+="f";
		
		try
		{	this.mRoot.droppable( "option", "accept",  "#nothing");
		} catch (e) { }
	}
	
	this.mRoot.removeClass();
	this.mRoot.addClass("connector");
	this.mRoot.addClass(className);
}

EpConnector.prototype.getX = function()
{	return this.mParent.mLeft+this.mLeft*this.mParent.mWidth;
}
EpConnector.prototype.getY = function()
{	return this.mParent.mTop+this.mTop*this.mParent.mHeight;
}

EpConnector.prototype.isConnected = function()
{	return this.mWires.length>0;
}

EpConnector.prototype.updatePosition = function()
{	
	//console.log("connector.updatePosition");
	var w=this.mParent.mWidth;
	var h=this.mParent.mHeight;
	
	var d = this.mRoot;
	d.css("left", this.mLeft*w);
	d.css("top", this.mTop*h);
	/*
	if (this.mType==EpConnector.prototype.ARG)
	{	d=this.mLabel;
		d.css("right", w+5);
		d.css("top", this.mTop*h);
	}
	else if (this.mType==EpConnector.prototype.INJECTED)
	{	d=this.mLabel;
		var width=this.mLabel.width();
		d.css("left", this.mLeft*w-width/2);
		var top=h+5-(parseInt(this.mIndex)+1)*10;
		d.css("top", top);
	}
	*/

	for (var w in this.mWires)
	{	this.mWires[w].update();
	}
}

EpConnector.prototype.findValidEnds = function()
{	//from = this;
	var fromRep=this.mRep;
	var fromCType=this.mType;
	//console.log(fromType);
	var result = new Array();
	for (var e in gEndpoints)
	{	var endpoint = gEndpoints[e];
		if (fromCType==EpConnector.prototype.ARG)
		{	var connector = endpoint.mResponse;
			if (connector /*&&connector.mRep==fromRep*/)
			{	if (!this.traceDownTo(connector))
				{	result.push(connector);
				}
			}
			
			//find any valid injected connectors
			for (var c in endpoint.mInjectedConnectors)
			{	var connector = endpoint.mInjectedConnectors[c];
				//if (connector.type==fromType)
				{	// also need to be able to trace down to ctx input of this endpoint
					var ctxInputs=endpoint.getInputConnectorsForInjected(connector);
					var ctxInput=ctxInputs[0];
					if (ctxInput)
					{	//ctxInput = ctxInput.mWires[0].startC;
						if (this.traceDownToInput(ctxInput))
						{	result.push(connector);
						}
						//if (ctxInput.traceUpTo(this))
						//{	result.push(connector);
						//}
					}
				}
			}
			
			
		}
		else if (fromCType==EpConnector.prototype.RESPONSE)
		{	for (var c in endpoint.mConnectors)
			{	var connector = endpoint.mConnectors[c];
				if (/*connector.mRep==fromRep &&*/ connector.mWires.length==0)
				{	if (!this.traceUpTo(connector))
					{	result.push(connector);
					}
				}
			}
		}
		else if (fromCType==EpConnector.prototype.INJECTED)
		{
			var ctxInputs=this.mParent.getInputConnectorsForInjected(this);
			var ctxInput=ctxInputs[0];
			for (var c in endpoint.mConnectors)
			{	var connector = endpoint.mConnectors[c];
				if (/*connector.mRep==fromRep &&*/ connector.mWires.length==0)
				{	//if (connector.traceDownTo(this.mParent.mResponse))
					if (connector.traceDownToInput(ctxInput))
					{	result.push(connector);
					}
				}
			}	
		}
	}
	return result;
}


/* follow responses to find a given input connector*/
EpConnector.prototype.traceDownToInput = function(aInput)
{
	if (this==aInput)
	{	return true;
	}
	var endpoint = this.mParent;
	if (endpoint.mResponse)
	{	for (var w in endpoint.mResponse.mWires)
		{	var wireOut = endpoint.mResponse.mWires[w];
			if (wireOut.endC.traceDownToInput(aInput))
			{	return true;
			}
		}
	}
	return false;
}

/* follow responses to find a given response connector*/
EpConnector.prototype.traceDownTo = function(aResponse)
{
	//console.log("trace down");
	var endpoint = this.mParent;
	if (endpoint.mResponse)
	{	if (endpoint.mResponse==aResponse)
		{	return true;
		}
		for (var w in endpoint.mResponse.mWires)
		{	var wireOut = endpoint.mResponse.mWires[w];
			//console.log(endpoint.id+" "+wireOut);
			if (wireOut.endC.traceDownTo(aResponse))
			{	return true;
			}
		}
	}
	return false;
}

/* follow inputs to find given input */
EpConnector.prototype.traceUpTo = function(aInput)
{	
	var endpoint = this.mParent;
	for (var c in endpoint.mConnectors)
	{	var connector = endpoint.mConnectors[c];
		if (connector==aInput)
		{	return true;
		}
		
		if (connector.mWires.length>0)
		{	var parent = connector.mWires[0].startC;
			if (parent.mType!=EpConnector.prototype.INJECTED && parent.traceUpTo(aInput))
			{	return true;
			}
		}
		
	}
	return false;
}


EpConnector.prototype.editName = function(e)
{	var connector=$(e.target).data("obj");
	if (connector)
	{	e.stopPropagation();
		//console.log("editName: "+connector.mProto);
		editConnectorNameDialog(connector);
	}
}

EpConnector.prototype.setName = function(aName)
{	this.mName=aName;
	//this.mLabel.text(aName);
}

function editConnectorNameDialog(aConnector)
{
	var inputField=$( "#editConnectorNameInput" );
	var tipsField=$( "#editConnectorNameTips" );
	var dialog=$( "#editConnectorNameDialog" );
	
	var originalName=aConnector.mName;
	inputField.val(originalName);
	var title="Enter a new name for the \""+aConnector.mName+"\" argument.";
	tipsField.text(title).removeClass( "ui-state-highlight" );
	inputField.removeClass( "ui-state-error" );
	
	dialog.dialog(
	{	modal: true,
		position: "center",
		buttons:
		[	{	text: "ok",
				click: function()
				{	var name=inputField.val();
					var valid=true;
					var nmtoken=/^[a-zA-Z][0-9a-zA-Z\\-\\._]*$/;
					if (!nmtoken.test(name))
					{	inputField.addClass( "ui-state-error" );
						tipsField.text("Not a valid (nmtoken) argument name").addClass( "ui-state-highlight" );
						valid=false;
					}
					if (valid)
					{
						for (var c in aConnector.mParent.mConnectors)
						{	var c2=aConnector.mParent.mConnectors[c];
							if (c2!=aConnector)
							{	if (c2.mProto==name)
								{	inputField.addClass( "ui-state-error" );
									tipsField.text("Cannot be named same as pre-existing argument").addClass( "ui-state-highlight" );
									valid=false;
									break;
								}
							}
						}
					}
					
					if (valid)
					{	var action = new SetConnectorNameAction(aConnector,name,originalName);
						doAction(action);
						$( this ).dialog( "close" );
					}
				}
			},
			{	text: "cancel",
				click: function()
				{	$( this ).dialog( "close" );
				}
			}
		]
	});
	
}





//************************
// DummyEpConnector class - used as the temporary end of a wire during creation
//************************
DummyEpConnector = function(x,y)
{	this.x=x;
	this.y=y;
	this.mDirection=[0,0];
}
DummyEpConnector.prototype.setPosition = function(x,y)
{	this.x=x;
	this.y=y;
}
DummyEpConnector.prototype.getX = function()
{	return this.x;
}
DummyEpConnector.prototype.getY = function()
{	return this.y;
}
DummyEpConnector.prototype.isOrphaned = function()
{	return false;
}
DummyEpConnector.prototype.addWire = function(aWire)
{
}
DummyEpConnector.prototype.removeWire = function(aWire)
{	
}