var gProtoUnknown= { cssClass: "ep-proto-unknown"};
var gProtoArgUnknown = { r: false, o: false, t: "java.lang.Object" };
var gEnabledEndpointRedraw=true;

function getEndpointWithId(aId)
{	var result;
	for (var i in gEndpoints)
	{	var endpoint=gEndpoints[i];
		if (endpoint.mId==aId)
		{	result=endpoint;
			break;
		}
	}
	return result;
}

//************************
// Endpoint class
//************************
Endpoint = function(aDefn)
{
	this.mTop = aDefn.y;
	this.mLeft = aDefn.x;
	this.mWidth=aDefn.w?aDefn.w:58;
	this.mHeight=aDefn.h?aDefn.h:58;
	this.mProtoId=aDefn.p;
	this.mProto=undefined;
	this.mValidInputs=true;
	this.mValid=true;
	
	if (!aDefn.i)
	{	var id=0;
		do
		{	var found=false;
			for (var i in gEndpoints)
			{	var endpoint = gEndpoints[i];
				if (endpoint.mId==id)
				{	found=true;
					break;
				}
			}
			if (!found)
			{	this.mId=id;
				break;
			}
			id++;
		} while(true);
	}
	else
	{	this.mId=aDefn.i;
	}
	

	var d = $("<div class='ep ep-instance'><div class='text'/></div>");
	this.mRoot = d;

	
	

	if (aDefn.v)
	{	this.setValue(aDefn.v);
	}
	
	if (aDefn.output)
	{	if (aDefn.output.response)
		{	this.mResponse = new EpConnector(this,0.5,1, EpConnector.prototype.RESPONSE, "","R");
			this.mResponseDefn=aDefn.output.response;
		}
	
		if (aDefn.output.injected)
		{	this.mInjectedDefn=aDefn.output.injected;
			this.mInjectedConnectors=[];
			var d=1/this.mInjectedDefn.length;
			for (var i in this.mInjectedDefn)
			{	var injectedDef=this.mInjectedDefn[i];
				var id=-(parseInt(i)+1);
				var x=d/2+i*d;		
				var c = new EpConnector(this,1,x, EpConnector.prototype.INJECTED, injectedDef.n, id);
				this.mInjectedConnectors.push(c);
			}
		}
	}
	

	this.mConnectors = new Array();
	this.mInputs=[];
	
	if (aDefn.input)
	{
		this.mInputs=new Array();
		for (var i in aDefn.input)
		{	var savedInput=aDefn.input[i];
			var input = {};
			input.p=savedInput.p;
			input.n=savedInput.n;
			
			this.mInputs.push(savedInput);
		}
	}
	
	this.createConnectorsForInputs();
}

Endpoint.prototype.getConnectorWithId = function(aId)
{	var result;
	if (aId=="R")
	{	result=this.mResponse;
	}
	else if (aId>=0)
	{	result=this.mConnectors[aId];
	}
	else if (this.mInjectedConnectors && aId<0)
	{	result=this.mInjectedConnectors[-aId-1];
	}
	if (!result)
	{	//error
	}
	return result;
}

Endpoint.prototype.getInput =function(aIndex)
{	var result;
	if (aIndex=="R")
	{	result=this.mResponseDefn;
	}
	else if (aIndex>=0)
	{	if (this.mInputs)
		{	result=this.mInputs[aIndex];
		}
	}
	else
	{	result=this.mInjectedDefn[-aIndex-1];
		
	}
	return result;
}

Endpoint.prototype.getInputConnectorsForInjected =function(aConnector)
{	var injectionDef=this.getInput(aConnector.mIndex);
	var injectionTo=injectionDef.to;
	var result=[];
	for (var i in this.mInputs)
	{	var inputDef=this.mInputs[i];
		if (inputDef.p==injectionTo)
		{	result.push(this.mConnectors[i]);
		}
	}
	return result;
}

//************************
// innerInit
// called when endpoint is created or script containing endpoint is displayed
//************************
Endpoint.prototype.innerInit = function()
{
	var p = getPrototypeWithId(this.mProtoId);
	var defn;
	if (p)
	{	defn=p.mDefn;
		this.mProto=p;
	}
	else
	{	defn = gProtoUnknown;
		this.mProto=undefined;
	}
	
	this.innerUpdatePosition();
	var d = this.mRoot;

	/*
	var bgi;
	if (defn.icon)
	{	bgi="url('"+defn.icon+"')";
	}
	else
	{	bgi="none";
	}
	d.css("background-image",bgi);
	
	d.removeClass();
	d.addClass("ep-instance");
	d.addClass("ep");
	
	if (defn.icon)
	{	d.addClass("ep-icon");
	}
	*/
	if (defn.cssClass)
	{	d.addClass(defn.cssClass);
	}
	
	this.updateValidation();
	
	if (defn.hasValue)
	{	this.setValue(this.mValue);
		d.dblclick(this.editValue);
	}
	else
	{	if (defn.hyperlink)
		{	d.dblclick(function()
			{	var flow=getFlowWithId(defn.hyperlink);
				selectTabIfNecessary(flow);
			});
		}
		
		var text;
		if (defn.name)
		{	text=defn.name;
		}
		else
		{	text=this.mProtoId;
		}
		/*
		if (!this.mLabel)
		{	this.mLabel=new Label(text);
			this.mLabel.move(this.mLeft+this.mWidth/2,this.mTop);
		}
		this.mLabel.restore();
		*/
		
		//this.mRoot.find(".text").html("<div class='ep-label'>"+text+"</div>");
	}
	
	//this.mValidInputs=defn.valid;
	
	this.mDeleted = false;
	//d = this.mRoot;
	d.appendTo(gEditCanvas);
	d.data("obj", this);
	
	d.draggable(
	{
		revert: "invalid",
		containment: gEditCanvas,
		cursor: "move",
		start: this.startDrag,
		drag: this.drag,
		stop: this.stopDrag
	});
	
	d.resizable(
	{	start: function() { deselect(); },
		resize: this.onResize,
		stop: this.onResizeStop,
		handles: "se",
		minHeight: 16,
		minWidth: 58
	});
	
	d.click(this.onClick);
	
	if (this.mResponse)
	{	this.mResponse.innerInit();
	}
	for (i in this.mConnectors)
	{	this.mConnectors[i].innerInit();
	}
	for (i in this.mInjectedConnectors)
	{	this.mInjectedConnectors[i].innerInit();
	}
	
	var cc="ep-canvas";
	if (this.mProtoId=="df:comment")
	{	cc=cc+" ep-canvas-comment";
	}	
	this.mCanvasRoot=$("<canvas class='"+cc+"'/>");
	this.mCanvasRoot.appendTo(gEditCanvas);
	this.canvasRedraw(false);
	
}

Endpoint.prototype.canvasRedraw = function(aForce)
{	if (this.mCanvasRoot && gEnabledEndpointRedraw)
	{	
		var redraw=false;
		var move=false;
		if (aForce)
		{	redraw=true;
		}
		else if (this.mValid!=this.mLastValid)
		{	redraw=true;
		}
		else if (this.mWidth!=this.mLastWidth || this.mHeight!=this.mLastHeight)
		{	redraw=true;
		}
		else if (this.mInputs!=this.mLastInputs)
		{	redraw=true;
		}
		else if (this.mTop!=this.mLastTop || this.mLeft!=this.mLastLeft)
		{	move=true;
		}
	
		if (redraw)
		{	
			this.mLastValid=this.mValid;
			this.mLastWidth=this.mWidth;
			this.mLastHeight=this.mHeight;
			this.mLastInputs=this.mInputs;
			this.mLastTop=this.mTop;
			this.mLastLeft=this.mLeft;
			
			var r=gTheme.drawEndpoint(this.mCanvasRoot,this);
			this.mCanvasRoot=r.canvas;
			this.mCanvasX=r.xoffset;
			this.mCanvasY=r.yoffset;
		}
		else if (move)
		{	this.mLastTop=this.mTop;
			this.mLastLeft=this.mLeft;
			var x=this.mLeft+this.mCanvasX;
			var y=this.mTop+this.mCanvasY;
			this.mCanvasRoot.css("left",x).css("top",y);
		}
	}
}




Endpoint.prototype.onResize = function(e,ui)
{
	var endpoint = $(e.target).data("obj");
	endpoint.mWidth=ui.size.width;
	endpoint.mHeight=ui.size.height;
	endpoint.update();
}

Endpoint.prototype.onResizeStop = function(e,ui)
{
	var endpoint = $(e.target).data("obj");
	var w=ui.size.width;
	var h=ui.size.height;
	var ow=ui.originalSize.width;
	var oh=ui.originalSize.height;
	
	var action = new ResizeEndpointAction(endpoint,ow,oh,w,h);
	doAction(action);
}

Endpoint.prototype.editValue = function(e,ui)
{
	e.stopPropagation();
	var endpoint = $(e.currentTarget).data("obj");
	editLiteralDialog(endpoint);
}

Endpoint.prototype.setValue = function(aValue)
{	this.mValue=aValue;
	this.mRoot.find(".text").text(aValue);
}

Endpoint.prototype.startDrag = function(e)
{	
	var endpoint = $(e.target).data("obj");
	endpoint.mOldTop=endpoint.mTop;
	endpoint.mOldLeft=endpoint.mLeft;
	hideDelete();
}

Endpoint.prototype.drag = function(e,ui)
{	var endpoint = $(e.target).data("obj");
	var cof = gEditCanvas.offset();
	var top = ui.offset.top - cof.top;
	var left = ui.offset.left - cof.left;
	endpoint.updatePosition(left,top);
}

Endpoint.prototype.stopDrag = function(e, ui)
{	var endpoint = $(e.target).data("obj");
	var cof = gEditCanvas.offset();
	var top = ui.offset.top - cof.top;
	var left = ui.offset.left - cof.left;
	action = new MoveEndpointAction(endpoint, top, left, endpoint.mOldTop, endpoint.mOldLeft );
	doAction(action);
	endpoint.select();
}

Endpoint.prototype.onClick = function(e)
{	var endpoint = $(e.currentTarget).data("obj");
	if (endpoint && endpoint.select)
	{	e.stopPropagation();
		endpoint.select();
	}
}

Endpoint.prototype.select = function()
{	showDeleteButton(this, this.mLeft + this.mWidth - 15, this.mTop+1);
}

Endpoint.prototype.deselect = function()
{	this.mRoot.removeClass("selected");
}

Endpoint.prototype.onDeleteButton = function()
{	if (gSelected == this) 
	{	deselect();
	}
	var action = new DeleteEndpointAction(this);
	doAction(action);
}

Endpoint.prototype.onDelete = function()
{
	this.mRoot.remove();
	if (this.mCanvasRoot)
	{	this.mCanvasRoot.remove();
		this.mCanvasRoot=undefined;
	}
	removeFromArray(gEndpoints, this);
	this.mDeleted=true;
	
	//now remove wires
	if (this.mResponse)
	{	this.mResponse.onDelete();
	}
	for (var c in this.mConnectors)
	{	this.mConnectors[c].onDelete();
	}
	if (this.mLabel)
	{	this.mLabel.destroy();
	}
	
}

Endpoint.prototype.onRestore = function()
{
	this.innerInit();
	gEndpoints.push(this);
	
	//now restore wires
	if (this.mResponse)
	{	this.mResponse.onRestore();
	}
	for (var c in this.mConnectors)
	{	this.mConnectors[c].onRestore();
	}
	
	this.onUpdatedInputs();
}

Endpoint.prototype.updatePosition = function(aLeft, aTop)
{	this.mLeft=aLeft;
	this.mTop=aTop;
	this.update();
}

Endpoint.prototype.update = function()
{	
	this.innerUpdatePosition();
	if (this.mLabel)
	{
		this.mLabel.move(this.mLeft+this.mWidth/2,this.mTop);
	}
	if (this.mResponse)
	{	this.mResponse.updatePosition();
	}
	for (var c in this.mConnectors)
	{	this.mConnectors[c].updatePosition();
	}
	for (var c in this.mInjectedConnectors)
	{	this.mInjectedConnectors[c].updatePosition();
	}
}

Endpoint.prototype.innerUpdatePosition = function()
{
	this.mRoot.css("left",this.mLeft).css("top",this.mTop);
	this.mRoot.css("width",this.mWidth-2).css("height",this.mHeight-2);
	if (this.mProto && this.mProto.mDefn.hasValue)
	{	this.mRoot.find(".text").css("width",this.mWidth-14).css("height",this.mHeight-20);
	}
	this.canvasRedraw();
	
}


Endpoint.prototype.onUpdatedInputs = function()
{
	if (!this.mInputs.length) return;
	var proto=getPrototypeWithId(this.mProtoId);
	if (!proto) return;
	
	//serialise inputs
	var t={  };
	t.p = this.mProtoId;
	t.e=this.mId.toString();
	var inputsOut = [ ];
	for (var i in this.mInputs)
	{	var inputIn = this.mInputs[i];
		var connector=this.getConnectorWithId(i);
		var isConnected = connector.isConnected(i);
		var inputOut = { n: connector.mName, p: inputIn.p, c: isConnected };
		inputsOut.push(inputOut);
	}
	t.i=inputsOut;
	if (proto.mDefn.grammar)
	{	t.grammar=proto.mDefn.grammar;
	}
	addValidationTask(t);
}

var gValidationTasks = new Array();
function addValidationTask(aTask)
{
	var endpoint=aTask.e;
	for (var i in gValidationTasks)
	{	var task=gValidationTasks[i];
		if (task.e==endpoint)
		{	delete gValidationTasks[i];
			break;
		}
	}
	gValidationTasks.push(aTask);
}
function clearValidationTasks()
{	gValidationTasks=new Array();
}
function performValidationTasks()
{
	if (gValidationTasks.length==0)
	{	return;
	}
	
	var postBody={};
	postBody.arguments=JSON.stringify({ t: gValidationTasks},null,"\t" );
	if (gImportsChanged)
	{	postBody.dynamicImports = JSON.stringify( { dynamicImports: gDynamicImports } );
	} 
	gValidationTasks=new Array();
	$.post("/tools/ncode/validateArguments/"+gEntityId, postBody, function(aData)
		{
			if (aData==null)
			{	ajaxErrorDialog();
				return;
			}			

			for (var i in aData.t)
			{	var task = aData.t[i];
				var endpointId=task.e;
				var endpoint = getEndpointWithId(endpointId);
				if (endpoint)
				{
					endpoint.mValidInputs=task.valid;
					if (task.input)
					{	endpoint.mInputs=task.input;
						endpoint.createConnectorsForInputs();
					}
					else
					{	endpoint.updateValidation();
					}
				}
			}
			
		},"json");
}

Endpoint.prototype.onUpdatedOutputs = function()
{	this.updateValidation();
}


Endpoint.prototype.updateValidation=function()
{	
	if (this.mRoot)
	{	var validInputs=this.mValidInputs;
		var validOutputs=!this.mResponse || this.mResponse.mWires.length>0;
		this.mValid=validInputs && validOutputs && (this.mProto!=undefined);
		this.canvasRedraw();
	}
}

Endpoint.prototype.createConnectorsForInputs=function()
{
	var oldConnectors=this.mConnectors;
	this.mConnectors=new Array();
	
	var len=this.mInputs.length;
	for (var i=0; i<this.mInputs.length; i++)
	{	var x=getConnectorPosition(i,len);
		var input=this.mInputs[i];
		var connector;
		if (input.i!=undefined)
		{	connector=oldConnectors[input.i];
			connector.update(x,i,input.o,input.n);
			delete oldConnectors[input.i];
		}
		else
		{	connector=new EpConnector(this,x,0, EpConnector.prototype.ARG, input.n, i );
			connector.innerInit();
		}
		this.mConnectors.push(connector);
	}

	for (var c in oldConnectors)
	{	oldConnectors[c].onDelete(true);
	}
	
	this.updateValidation();
}

Endpoint.prototype.getState =function()
{	var state= { };
	state.i=this.mId;
	state.x=this.mLeft.toFixed()-0;
	state.y=this.mTop.toFixed()-0;
	state.w=this.mWidth.toFixed()-0;
	state.h=this.mHeight.toFixed()-0;
	state.p=this.mProtoId;
	if (this.mValue)
	{	state.v=this.mValue;
	}
	state.input=[];
	for (var i in this.mConnectors)
	{	var con=this.mConnectors[i];
		var si={};
		si.n=con.mName;
		si.p=this.getInput(i).p;
		state.input.push(si);
	}
	state.output={};
	if (this.mResponseDefn)
	{	state.output.response=this.mResponseDefn;
	}
	var injected=[];
	for (var i in this.mInjectedDefn)
	{	var con=this.mInjectedDefn[i];
		injected.push(con);
	}
	if (injected.length>0)
	{ state.output.injected=injected;
	}
	
	return state;
}

Endpoint.prototype.undoWireDelete=function(aIndex,aType,aName)
{
	//create new connector
	//insert into mConnectors
	//insert new input into mInputs
	//return new connector
	var x=getConnectorPosition(aIndex,this.mInputs.length+1);
	var newConnector=new EpConnector(this,x,0, EpConnector.prototype.ARG, aName, aIndex );
	newConnector.innerInit();
	insertIntoArrayAt(this.mConnectors, newConnector, aIndex);
	var defn={};
	defn.n=aName;
	defn.p=aType;
	insertIntoArrayAt(this.mInputs,defn,aIndex);
	return newConnector;
}
