//************************
// EpPrototype class
//************************
function getPrototypeWithId(aId)
{	var result;
	for (p in gPrototypes)
	{	var proto = gPrototypes[p];
		if (proto.getId()==aId)
		{	result=proto;
			break;
		}
	}
	return result;
}

function addOrReplacePrototype(aProto)
{	var result;
	var id=aProto.getId();
	for (p in gPrototypes)
	{	var proto = gPrototypes[p];
		if (proto.getId()==id)
		{	result=p;
			break;
		}
	}
	if (result)
	{	gPrototypes[result]=aProto;
	}
	else
	{	gPrototypes.push(aProto);
	}
}

//************************
// EpPrototype class
//************************
EpPrototype = function(aDefn, aParent)
{
	this.mDefn=aDefn;
	var cssClass="ep ep-proto";
	if (aDefn.cssClass)
	{ cssClass=cssClass+" "+aDefn.cssClass;
	}
	/*
	if (aDefn.icon)
	{	cssClass=cssClass+" ep-icon";
		var s="<div class='"+cssClass+"' style='background-image: url(\""+aDefn.icon+"\"); ' >"+aDefn.name+"</div>";
		//console.log(s);
		this.mRoot = $(s);
	}
	else
	{	this.mRoot = $("<div class='"+cssClass+"' >"+aDefn.name+"</div>");
	}
	*/
	
	this.mRoot=$("<canvas class='proto-canvas' width='56' height='56'/>");
	if (aDefn.desc)
	{	this.mRoot.attr("title",aDefn.desc);
	}
	gTheme.drawPaletteItem(this.mRoot,this);
	this.mRoot.appendTo(aParent);
	this.mRoot.data("proto",this);
	
	this.mRoot.draggable(
	{	//helper: "clone",
		helper: this.createDragClone,
		revert: "invalid", 
		opacity: 1.0, 
		appendTo: 'body', 
		containment: $( "#df-bounds" ).length ? "#df-bounds" : "document", // stick to demo-frame if present
		cursor: "move",
		zIndex: 1000
	} );
	
	this.mRoot.dblclick(function()
	{	//console.log("dblclick");
		showDocumentation(aDefn.eid);
	});
	
	
}

EpPrototype.prototype.createDragClone = function(e)
{	//console.log(arguments);
	var target=$(e.target);
	var proto=target.data("proto");
	
	var v=$("<canvas class='proto-canvas' width='56' height='56'/>");
	gTheme.drawPaletteItem(v,proto);
	return v.get(0);
}


EpPrototype.prototype.getId = function()
{	return this.mDefn.id;
}
