//************************
// global state
//************************
var gPalette;
var gEditCanvas;
var gSelected;
var gEndpoints;
var gDeleteButton;
var gWires;
var gPrototypes;
var gAjaxBusy=false;
var gDynamicImports=[];
var gImportsChanged=false;
var gTheme;

var ID_RESPONSE="df:response";
var ID_ARG="df:arg:";
var ID_FLOW="df:flow:";
var ID_LITERAL="df:literal:";

var ARGTYPE_IDENTIFIER="IDENTIFIER";
var ARGTYPE_REPRESENTATION="REPRESENTATION";
var ARGTYPE_STRING="STRING";

//************************
// main startup
//************************
$(function()
{
	//browser check
	/*
	if (!$.browser.mozilla || parseFloat($.browser.version)<1.9)
	{	var d=$("#operatorWarningDialog");
		var msg="Sorry this version of nCoDE is only compatible with Mozilla Firefox 3.0+";
		d.find("p").text(msg);
		d.dialog(
		{	title: "Incompatible browser",
			modal: true,
			width: 400,
			height: "auto",
			position: "center",
			buttons: { "ok": function() { $(this).dialog("close"); } }
		});
		return;
	}
	*/
	
	gTheme=new Theme1();
	
	var oa=new AsyncInOrder( [ paletteLoaded, scriptsLoaded ] );
	$.get("/tools/ncode/palette/"+gEntityId, oa.getProxy(0),"json");
	$.get("/tools/ncode/load/"+gEntityId, oa.getProxy(1),"json");

	$(document).ajaxError(function(e, xhr, settings, exception)
	{	ajaxErrorDialog();
	});
	var asyncIcon=$("#tbicon-async");
	var bounds=$("#df-bounds");
	$(document).ajaxStart(function()
	{	asyncIcon.css("visibility","visible");
		bounds.css("cursor","wait");
		//setTimeout(function() { if (gAjaxBusy) bounds.css("cursor","wait"); },250);
		gAjaxBusy=true;
		
	});
	$(document).ajaxStop(function()
	{	asyncIcon.css("visibility","hidden");
		bounds.css("cursor","default");
		gAjaxBusy=false;
	});
		
	gEndpoints = new Array();
	gWires = new Array();
	gDeleteButton= $("<div class='deleteButton'/>");
	tabbedTextArea($("#editLiteralTextarea"));
	
	$(window).resize(function()
	{	$("#palette").find(".ui-accordion").accordion("resize");
	});

	$(window).blur(function()
	{	if (gAutosave && gActionCount!=0)
		{	onSave();
		}
	});
	window.onbeforeunload = function()
	{
		if (gActionCount!=0)
		{	if (gAutosave)
			{	onSave();
			}
			else
			{	var msg="You have unsaved changes that will be lost.";
				var e = e || window.event;
				// For IE and Firefox prior to version 4
				if (e)
				{	e.returnValue = msg;
				}
		    	return msg;
			}
		}
	};
	
});

//************************
// setupPalette
//************************
/*
function paletteSetup()
{	$.get("/tools/ncode/palette/"+gEntityId, paletteLoaded,"json");
}
*/
function paletteLoaded(data)
{
	if (data==null)
	{	ajaxErrorDialog();
		return;
	}
	
	initialiseTabs();
	initialiseToolbar();
	
	
	//console.log(data);
	var palette=$("#palette");
	var selected;
	try
	{	var paletteRoot=palette.find("div");
		selected = paletteRoot.accordion('option', 'active');
		//console.log(active);
	}
	catch(e) { }
	if (typeof(selected)!="number")
	{	selected=0;
	}
	
	gPalette=data;
	gPrototypes = new Array();
	var paletteRoot=$("<div style='height: 500px; '/>");
	var categories=data.group;
	
	for (i=0; i<categories.length; i++)
	{	var category=categories[i];
		var name=category.name;
		var desc=category.desc;
		var categoryTitle=$("<h3><a href='#' title='"+desc+"'>"+name+"</a></h3>");
		var categoryRoot=$("<div/>");
		var table=writePaletteGroup(categoryRoot,category);
		table.appendTo(categoryRoot);
		categoryTitle.appendTo(paletteRoot);
		categoryRoot.appendTo(paletteRoot);
	}
	var palette=$("#palette");
	palette.empty();
	paletteRoot.appendTo(palette);
	paletteRoot.accordion({ fillSpace: true, active: selected });
}

function writePaletteGroup(categoryRoot,category,aUpdate)
{
	var categoryTable=$("<table/>");
	var COLS=3;
	if (category.hasOwnProperty('endpoint'))
	{
		var endpoints = category.endpoint;
		var col=0;
		var row = $("<tr/>");
		for (j = 0; j < endpoints.length; j++)
		{	var endpoint = endpoints[j];
			var cell = $("<td/>");
			if (endpoint.id!="df:response")
			{	cell.appendTo(row);
				col++;
			}

			var proto = new EpPrototype(endpoint,cell);
			if (aUpdate)
			{	addOrReplacePrototype(proto);
			}
			else
			{	gPrototypes.push(proto);
			}
			if (col==COLS || j==endpoints.length-1)
			{	row.appendTo(categoryTable);
				row = $("<tr/>");
				col=0;
			}
		}
	}
	return categoryTable;
}

//************************
// reloadPalette
// - called after local changes to selected palettes
//************************
function reloadPalette()
{	var data=JSON.stringify( { dynamicImports: gDynamicImports } );
	$.post("/tools/ncode/palette/"+gEntityId, { dynamicImports: data }, function(aData)
	{	paletteLoaded(aData);
		performTabSwitchInner(gCurrentFlow,gCurrentFlow);
	}, "json");
}

//************************
// updatePaletteOnFlowChange
// - update palette with arguments and other scripts
//************************
function updatePaletteOnFlowChange()
{
	var palette=$("#palette");
	var group=gPalette.group[0];
	for (var i in gPalette.group)
	{	var g=gPalette.group[i];
		if (g.id=="io")
		{	group=g;
			break;
		}
	}
	
	var g1=group.endpoint;
	var g2=[];
	
	//remove dynamic palette entries
	for (var i=0; i<g1.length; i++)
	{	var proto=g1[i];
		if (!proto.isDynamic)
		{	g2.push(proto);
			//removePrototypeWithId(proto.id);
		}
	}
	
	//create argument entries
	for (var i in gCurrentFlow.getInputs())
	{	var arg=gCurrentFlow.getInputs()[i];
		var name="arg:"+arg.n;
		var id=ID_ARG+arg.n;
		var ne = { isDynamic: true, cssClass: "argument", id: id, eid: id, name: name, valid: false, output: {"response": {t: ARGTYPE_IDENTIFIER, s: ""}} };
		g2.push(ne);
	}
	
	//create palette entries for other scripts
	for (var i in gFlows)
	{	var flow=gFlows[i];
		var id=flow.getEndpointId();
		var ne = { isDynamic: true, cssClass: "ncode", icon: "/tools/ncode/pub/icon.png", id: id, eid: id, name: flow.getName(), desc: flow.getDesc(), valid: false, output: {"response": {t: ARGTYPE_REPRESENTATION, s: "java.lang.Object"}} };
		ne.input=flow.getInputs();
		ne.grammar=flow.getGrammar();
		ne.hyperlink=flow.mId;
		g2.push(ne);
	}

	//update palette
	group.endpoint=g2;	
	paletteGroupRefresh("io");
	
}

//************************
// paletteGroupRefresh
//************************
function paletteGroupRefresh(groupId)
{
	//find group
	var group;
	var index;
	for (var i in gPalette.group)
	{	var g=gPalette.group[i];
		if (g.id==groupId)
		{	group=g;
			index=i;
			break;
		}
	}
	if (group)
	{
		var palette=$("#palette");
		var groupContent=palette.find(".ui-accordion-content");
		var groupRoot=$(groupContent.get(index));
		var table=writePaletteGroup(groupRoot,group,true);
		groupRoot.empty();
		table.appendTo(groupRoot);
	}
}



//************************
// dropItem
//************************
function dropItem(event, ui, droppable)
{
	var proto=ui.draggable.data("proto");
	if (proto != null)
	{	
		//drop prototype onto canvas
		var position = droppable.offset();
		var top = ui.offset.top - position.top;
		var left = ui.offset.left - position.left;
		
		var defn = { x: left, y: top, p: proto.getId(), input: proto.mDefn.input, output: proto.mDefn.output, v: proto.mDefn.v };
		var endpoint = new Endpoint(defn);
		action = new CreateEndpointAction(endpoint);
		doAction(action);
		endpoint.select();
	}
}

//************************
// deselect
//************************
function deselect()
{	if (gSelected!=null)
	{	gSelected.deselect();
	}
	hideDelete();
	gSelected=null;
}

function hideDelete()
{	//console.log("hide delete button");
	try
	{	gDeleteButton.unbind("click");
		gDeleteButton.detach();
	} catch (e) {}
}


function showDeleteButton(entity, left, top)
{
	if (entity.mProtoId==ID_RESPONSE) return;
	
	gSelected=entity;
	gDeleteButton.css("left",left).css("top",top);
	gDeleteButton.appendTo(gEditCanvas);
	gDeleteButton.click(onDelete);
}

//************************
// onDelete
//************************
 function onDelete()
{	if (gSelected)
	{	gSelected.onDeleteButton();
	}
}

//************************
// editLiteralDialog
//************************
function editLiteralDialog(aEndpoint)
{
	var value=aEndpoint.mValue;
	if (!value)
	{	value="";
	}
	
	$( "#editLiteralTextarea" ).val(value);
	
	var width = aEndpoint.mEditWidth;
	var height = aEndpoint.mEditHeight;
	if (!width)
	{	width=400;
		height="auto";
	}
	
	var d=$('#editLiteralDialog');
	var ta=$('#editLiteralTextarea');
	var tipsField=$( "#editLiteralTips" );
	
	var title="Update the value for "+aEndpoint.mProto.mDefn.name+".";
	tipsField.text(title).removeClass( "ui-state-error" );
	//ta.removeClass( "ui-state-error" );
	
	var autosize = function(event, ui)
	{	//TODO how to determine these values
		var width=d.width()-16;
  		var height=d.height()-40;
  		ta.css('width',width).css('height',height);
	};
	
	d.dialog(
	{	modal: true,
		width: width,
		height: height,
		position: "center",
		buttons:
		[	{	text: "ok",
				click: function()
				{	
					var value=ta.val()
					var that=this;
					
					var postBody={ value: value, id: aEndpoint.mProtoId };
					if (gImportsChanged)
					{	postBody.dynamicImports = JSON.stringify( { dynamicImports: gDynamicImports } );
					} 
					
					$.post("/tools/ncode/validateValue/"+gEntityId, postBody, function(aData)
					{	if (aData==null)
						{	ajaxErrorDialog();
							return;
						}	
						
						if (aData.valid)
						{	var action = new SetEndpointValueAction(aEndpoint,value);
							doAction(action,true);
							aEndpoint.mEditWidth=d.dialog( "option", "width" );
							aEndpoint.mEditHeight=d.dialog( "option", "height" );
							$( that ).dialog( "close" );
						}
						else
						{
							//ta.addClass( "ui-state-error" );
							var msg="<span style='float: left; margin-right: .3em;' class='ui-icon ui-icon-alert'/>"+aData.message;
							tipsField.html(msg).addClass( "ui-state-error" );
						}
					},"json");
				}
			},
			{	text: "cancel",
				click: function()
				{	$( this ).dialog( "close" );
				}
			}
		],
		resize: autosize,
		open: autosize
	});
}

//************************
// onEditSettings
//************************
function onEditSettings()
{
	$.post("/tools/ncode/availablePalette/"+gEntityId, function(aData)
	{	editSettingsDialog(aData);
	},"json");
}

function editSettingsDialog(aData)
{
	if (aData==null)
	{	ajaxErrorDialog();
		return;
	}	
	var d=$('#editSettingsDialog');
	var autosaveField=d.find('#editSettingsAutosaveInput');
	var undoLevelsField=d.find('#editSettingsUndoInput');
	var paletteTable=d.find('#editSettingsPaletteTable');
	var paletteTableBody=d.find('#editSettingsPaletteTableBody');

	autosaveField.attr("checked",gAutosave);
	undoLevelsField.val(gHistoryLength);
	paletteTableBody.empty();
	for (var i in aData.palette)
	{
		var palette=aData.palette[i];
		var checked="";
		var rowClass="";
		if (palette.inScope)
		{	checked="checked='true' disabled='true'";
			rowClass="class='row-disabled'";
		}
		else
		{	
			if (aData.supportsDynamicImports)
			{
				var isDynamic=false;
				for (var j in gDynamicImports)
				{	var impDef=gDynamicImports[j];
					if (impDef.id==palette.id /*&& impDef.version==palette.version*/)
					{	isDynamic=true;
						break;
					}
				}
				if (isDynamic)
				{	checked="checked='true'";
				}
			}
			else
			{	checked="disabled='true'";
				rowClass="class='row-disabled'";
			}
		}
		var id=palette.hash.replace("/","-");
		var row=$("<tr "+rowClass+"><td><input id='"+id+"' type='checkbox' "+checked+"/></td><td>"+palette.name+"</td></tr>");
		row.appendTo(paletteTableBody);
	}
	
	
	d.dialog(
	{	modal: true,
		width: 400,
		height: "auto",
		position: "center",
		open: function(event, ui)
		{	/*
			initDataTable("editSettingsPaletteTable",
			{	bRetrieve: true,
				"bSort": false,
				"bInfo": false,
				"bFilter": false,
				"bPaginate": false
				//"bLengthChange": false,
				//"aaSortingFixed": [[ 0, 'asc' ]]
			});
			*/
		},
		buttons:
		[	{	text: "ok",
				click: function()
				{	var autosave=autosaveField.attr("checked");
					var historyLength=undoLevelsField.val();
					var dynamicImports=getSelectedPalettes(paletteTableBody,aData);
					$( this ).dialog( "close" );
					var action = new ChangeSettingsAction(autosave,historyLength,dynamicImports);
					doAction(action);
				}
			},
			{	text: "cancel",
				click: function()
				{	$( this ).dialog( "close" );
				}
			}
		]
	});
}

function getSelectedPalettes(tableBody,availablePalettes)
{	var newDynamicImports=[];
	var changes=false;
	for (var i in availablePalettes.palette)
	{	var palette=availablePalettes.palette[i];
		var id=palette.hash.replace("/","-");
		var checkbox=tableBody.find("#"+id+":enabled:checked");
		if (checkbox.length)
		{	var impDef = { id: palette.id /*, version: palette.version*/ };
			newDynamicImports.push(impDef);
			var found=false;
			for (var j in gDynamicImports)
			{	var existingPalette=availablePalettes.palette[i];
				if (existingPalette.id==palette.id /*&& existingPalette.version==palette.version*/)
				{	found=true;
					break;
				}
			}
			if (!found)
			{	changes=true;
			}
		}
	}
	//changes |= newDynamicImports.length!=gDynamicImports.length;
	//return changes?newDynamicImports:undefined;
	return newDynamicImports;
}


//************************
// ajaxErrorDialog
//************************
function ajaxErrorDialog()
{
	var d=$('#ajaxErrorDialog');
	d.dialog(
	{	//title: title,
		modal: true,
		width: 400,
		height: "auto",
		position: "center",
		buttons: { "ok": function() { $(this).dialog("close"); } }
	});
}
