var gFlows = new Array();
var gUniqueFlowId = 1;
var gCurrentFlow;
var gTabs;

//************************
// initialiseTabs
//************************
function initialiseTabs()
{
	gTabs=$( "#tabs" );
	tabbedTextArea($("#editTabGrammar"));
		
	gTabs.tabs(
	{	tabTemplate: '<li><a href="#{href}">#{label}</a> <span class="ui-icon ui-icon-close">Remove Tab</span></li>',
		add: function(event, ui)
		{	
			gTabs.tabs('select', '#' + ui.panel.id);

			var noclose =$('#'+ui.panel.id +' >div' ).attr('noclose');
			var closeIcon = $(ui.tab).parent().find(".ui-icon-close");
			if (noclose!=null)
			{	closeIcon.remove();
			}
			else
			{	closeIcon.bind('click', function()
				{	var id=$(this).prev().attr("href").substring(4);
					var flow=getFlowWithId(id);
					var action=new DeleteFlowAction(flow);
					doAction(action);
				});
				$(ui.tab).dblclick(function()
				{	editTabProperties($(this));
				});
			}
		},
		select: function(event, ui)
		{	var allow=gTabs.tabs("length")==1 || ui.panel.id!="add";
			if (allow)
			{	
				var tabid=$(ui.tab).attr("href");
				var id=tabid.substring(4);
				var previous=gCurrentFlow;
				var current=getFlowWithId(id);
				gCurrentFlow=current;
				if (!gInAction)
				{	var action=new SwitchFlowAction(previous,current);
					doAction(action);
				}
				else
				{	performTabSwitch(current,previous,false);
				}
			}
			return allow;
		} 

	});
	//sorting too hard for the moment
	//tabs.tabs().find( ".ui-tabs-nav" ).sortable({ axis: "x" });

}

//************************
// scriptsLoaded
//************************
function scriptsLoaded(aData)
{
	if (aData==null)
	{	ajaxErrorDialog();
		return;
	}
	
	//remove existing tabs
	var c;
	while( (c=gTabs.tabs("length")>0))
	{ gTabs.tabs("remove",0);
	}
	
	//add new tab button/tab
	var tabc=$("<div id='add' ><div noclose=''></div></div>");
	tabc.appendTo(gTabs);
	gTabs.tabs("add","#add","+");
	var addLink = $('li',gTabs).last().children().first();
	addLink.click(createNewFlow);

	gInAction=true;

	//iterate data and create tabs
	var flows=aData.cde.flow;
	if (!flows)
	{	flows = [];
	}
	for (var i=0; i<flows.length; i++)
	{	var flowDef=flows[i];
		var flowId=gUniqueFlowId++;
		var flow=new Flow(flowId,flowDef);
		gFlows.push(flow);
		createTabFor(flow);
	}
	
	fixBottomTabs();
	$("#splash").css("display","none");
	gTabs.css("display","");
	loadSettingsState(aData.cde.settings);

	var fragment = window.location.hash;
	var selected=0;
	if (fragment)
	{	selected=fragment;
	}
	gTabs.tabs("select",selected);
	syncTabSwitch(true);
	gInAction=false;
	
	//warning dialog if operator resource can't be resolved or can't SOURCEd or SINKed to
	var title=undefined;
	var msg=undefined;
	var verbs=aData.cde.operatorVerbs;
	if (verbs==-1 || (verbs&1)==0)
	{	title="Unresolved nCoDE Operator";
		msg="The operator specified on the prototype instantiation cannot be resolved or does not support SOURCE.";
		msg+=" Changes cannot be saved.";
	}
	else if ((verbs&2)==0)
	{	title="Read-Only nCoDE Operator";
		msg="The operator specified on the prototype instantiation does not support SINK."
		msg+=" Changes cannot be saved.";
	}
	
	if (title)
	{	gAutosave=false;
		var d=$("#operatorWarningDialog");
		d.find("p").text(msg);
		d.dialog(
		{	title: title,
			modal: true,
			width: 400,
			height: "auto",
			position: "center",
			buttons: { "ok": function() { $(this).dialog("close"); } }
		});
	}
	
	updateUndoUI();
}


//************************
// onSave
//************************
function onSave()
{
	//sync flow from canvas if necessary
	if (gCurrentFlow)
	{	gCurrentFlow.setStateFromCanvas();
	}
	
	var state=JSON.stringify(getSaveState());
	//console.log(state);
	$.post("/tools/ncode/save/"+gEntityId, { state:  state}, function()
	{
		gActionCount=0;
		updateUndoUI();		
	});
}

function getSaveState()
{
	var flows= [ ];
	for (var f in gFlows)
	{	var flow=gFlows[f];
		var flowState= { };
		
		flowState.id=flow.getEndpointId();
		flowState.name=flow.getName();
		flowState.desc=flow.getDesc();
		flowState.isPublic=flow.isPublic();
		flowState.verbs=flow.getVerbs();
		flowState.grammar=flow.getGrammar();

		var endpoints = [ ];
		for (var e in flow.mEndpoints)
		{	var endpoint = flow.mEndpoints[e];
			var endpointState = endpoint.getState();
			endpoints.push(endpointState);
		}
		flowState.endpoint=endpoints;
		
		var wires = [ ];
		for (var w in flow.mWires)
		{	var wire = flow.mWires[w];
			var wireState = wire.getState();
			wires.push(wireState);
		}
		flowState.wire=wires;
		flows.push(flowState);
	}
	var cde= { };
	cde.flow=flows;
	cde.settings=getSettingsState();
	
	return { cde: cde };
}

function getSettingsState()
{
	var settings= {};
	settings.autosave=gAutosave;
	settings.undoHistory=gHistoryLength;
	settings.dynamicImport=gDynamicImports;
	return settings;
}

function loadSettingsState(settings)
{	if (settings)
	{	gAutosave=settings.autosave;
		gHistoryLength=settings.undoHistory;
		gDynamicImports=settings.dynamicImport;
	}
}


//************************
// fixBottomTabs
//************************
function fixBottomTabs()
{	$( ".tabs-bottom .ui-tabs-nav, .tabs-bottom .ui-tabs-nav > *" )
		.removeClass( "ui-corner-all ui-corner-top" )
		.addClass( "ui-corner-bottom" );
}

//************************
// createNewFlow
//************************
function createNewFlow()
{
	//loop to find a unique name
	var c=0;
	var name;
	do
	{	c++;
		name="endpoint"+c;
		var found=false;
		for (var f in gFlows)
		{	var flow=gFlows[f];
			if (flow.getName()==name || flow.getEndpointId()==gIdPrefix+name)
			{	found=true;
				break;
			}
		}
		if (!found) break;
	} while(true);
	
	var grammar="<group>res:/"+name+"</group>";
	var defn={ id: gIdPrefix+name, name: name, desc: "", isPublic: true, verbs: 1, grammar: grammar };
	
	//add response
	var endpoints = [];
	var proto=getPrototypeWithId(ID_RESPONSE);
	var responseEp = { x: 400, y: 100, p: proto.getId(), input: proto.mDefn.input, output: proto.mDefn.output };
	endpoints.push(responseEp);
	defn.endpoint=endpoints;
	
	var tid=gUniqueFlowId++;
	var flow = new Flow(tid,defn);
	
	var action= new CreateFlowAction(flow);
	doAction(action);
}

//************************
// createTabFor
//************************
function createTabFor(aFlow)
{	var tabc=$("<div id='tab"+aFlow.mId+"'></div>");
	tabc.appendTo(gTabs);
	var p=gTabs.tabs("length")-1;
	gTabs.tabs("add","#tab"+aFlow.mId,aFlow.getName(),p);	
}


//************************
// closeTab
//************************
function closeTab(aFlow)
{	var id=aFlow.mId;
	var index=findIndexOfTab(gTabs,id);
	gTabs.tabs('remove', index);
	$("#tab"+id).remove(); //delete data in dom too
	removeFromArray(gFlows,aFlow);
	
	if (gCurrentFlow==aFlow)
	{	//select another tab
		var len=gTabs.tabs("length");
		var selected;
		if (index>len-2)
		{	if (len>1)
			{	selected=len-2;
			}
			else
			{	selected=0;
			}
		}
		else
		{	selected=index;
		}
		gTabs.tabs("select",selected);
	}	
}

//************************
// editTabProperties
//************************
function editTabProperties(aTab)
{
	var d=$('#editTabDialog');
	var tipsField=d.find('#editTabTips');
	var label=d.find('#editTabLabel');
	var idField=d.find('#editTabId');
	var nameField=d.find('#editTabName');
	var descField=d.find('#editTabDesc');
	var publicField=d.find('#editTabPublic');
	var verb1Field=d.find('#editTabSource');
	var verb2Field=d.find('#editTabSink');
	var verb3Field=d.find('#editTabExists');
	var verb4Field=d.find('#editTabDelete');
	var verb5Field=d.find('#editTabNew');
	
	var grammarField=d.find('#editTabGrammar');
	
	var tabid=aTab.attr("href");
	var id=tabid.substring(4);
	var flow=getFlowWithId(id);
	
	var resetTabPropertiesForm = function()
	{	tipsField.text("Edit the properties of this flow").removeClass( "ui-state-error" );
		idField.removeClass( "ui-state-error" );
		nameField.removeClass( "ui-state-error" );
		grammarField.removeClass( "ui-state-error" );
	};
	resetTabPropertiesForm();
	
	idField.val(flow.getEndpointId());
	nameField.val(flow.getName());
	descField.val(flow.getDesc());
	publicField.attr("checked",flow.isPublic());
	grammarField.val(flow.getGrammar()).removeClass( "ui-state-error" );
	var verbs=flow.getVerbs();
	verb1Field.attr("checked",verbs&1);
	verb2Field.attr("checked",verbs&2);
	verb3Field.attr("checked",verbs&4);
	verb4Field.attr("checked",verbs&8);
	verb5Field.attr("checked",verbs&16);
	
	var autosize = function(event, ui)
	{	var width=d.width()-label.width();
  		descField.css('width',width);
  		grammarField.css('width',width);
	};
	
	d.dialog(
	{	modal: true,
		position: "center",
		width: 480,
		height: "auto",
		buttons:
		[	{	text: "ok",
				click: function()
				{	resetTabPropertiesForm();
					if (saveTabProperties())
					{	$( this ).dialog( "close" );
					}
				}
			},
			{	text: "cancel",
				click: function()
				{	$( this ).dialog( "close" );
				}
			}
		],
		resize: autosize,
		open: autosize
	});
}


//************************
// saveTabProperties
//************************
function saveTabProperties()
{
	var d=$('#editTabDialog');
	var tipsField=d.find('#editTabTips');
	var idField=d.find('#editTabId');
	var nameField=d.find('#editTabName');
	var grammarField=d.find('#editTabGrammar');
	var isValid=true;
	var icon="<span style='float: left; margin-right: .3em;' class='ui-icon ui-icon-alert'/>";	
	
	//check name is unique
	var name=nameField.val();
	var id=idField.val();
	nameField.removeClass( "ui-state-error" );
	for (var f in gFlows)
	{	var flow=gFlows[f];
		if (flow==gCurrentFlow) continue;
		
		if (flow.getName()==name)
		{	isValid=false;
			nameField.addClass( "ui-state-error" );
			tipsField.html(icon+"duplicate name").addClass( "ui-state-error" );
			break;
		}
		if (flow.getEndpointId()==id)
		{	isValid=false;
			idField.addClass( "ui-state-error" );
			tipsField.html(icon+"duplicate id").addClass( "ui-state-error" );
			break;
		}
	}
	
	if (isValid)
	{	var grammar=grammarField.val();
		$.post("/tools/ncode/validateGrammar",{ grammar: grammar }, function(aData)
		{	//console.log("got validate response "+aData);
			if (aData==null)
			{	ajaxErrorDialog();
				return;
			}	
					
			var valid=aData.valid;
			if (valid.length>0)
			{	grammarField.addClass( "ui-state-error" );
				tipsField.html(icon+valid).addClass( "ui-state-error" );
			}
			else
			{	
				var desc=d.find('#editTabDesc').val();
				var isPublic=d.find('#editTabPublic').attr("checked")?true:false;
				var verbs = 0;
				verbs+=d.find('#editTabSource').attr("checked")?1:0;
				verbs+=d.find('#editTabSink').attr("checked")?2:0;
				verbs+=d.find('#editTabExists').attr("checked")?4:0;
				verbs+=d.find('#editTabDelete').attr("checked")?8:0;
				verbs+=d.find('#editTabNew').attr("checked")?16:0;
				d.dialog( "close" );
				var inputs=aData.input;
				//console.log("verbs "+verbs);
				var action = new UpdatePropertiesAction(gCurrentFlow,id,name,desc,isPublic,verbs,grammar,inputs);
				doAction(action,true);
			}
		},"json");
		isValid=false;
	}
	
	return isValid;
}

//************************
// getFlowWithId
//************************
function getFlowWithId(aId)
{	var result;
	for (var f in gFlows)
	{	var flow=gFlows[f];
		if (flow.mId==aId)
		{	result=flow;
			break;
		}
	}
	return result;
}

//************************
//renameTab
//************************
function renameTab(aTabId,aName)
{	var tabs=gTabs.tabs();
	var nav=tabs.find(".ui-tabs-nav > li");
	var ref="#tab"+aTabId;
	var tab=nav.find("a[href='"+ref+"']")
	tab.text(aName);
}

//************************
// findIndexOfTab
//************************
function findIndexOfTab(aTabs,aId)
{	var nav=aTabs.find(".ui-tabs-nav > li");
	var tab=nav.find("a[href='#tab"+aId+"']").parent();
	return nav.index(tab);
}

function selectTabIfNecessary(aFlow)
{
	if (!gCurrentFlow || gCurrentFlow.mId!=aFlow.mId)
	{	//console.log("changing tab in selectTabIfNecessary");
		gTabs.tabs("select",findIndexOfTab(gTabs,aFlow.mId));
	}
}

//************************
// performTabSwitch
//************************
var gSwitchFrom;
var gSwitchTo;

function performTabSwitch(aFlow, aPreviousFlow, aFromAction)
{	gSwitchTo=aFlow;
}

function syncTabSwitch(aForce)
{
	if (gSwitchTo!=gSwitchFrom || aForce)
	{	performTabSwitchInner(gSwitchTo,gSwitchFrom);
		gSwitchFrom=gSwitchTo;
	}
}

function performTabSwitchInner(aFlow, aPreviousFlow)
{
	gEnabledEndpointRedraw=false;
	//console.profile();
	if (aPreviousFlow)
	{	
		var div=gTabs.find("#tab"+aPreviousFlow.mId);
		div.html("<div class='dummyCanvas'/>");
		
		aPreviousFlow.setStateFromCanvas();
		for (var i in aPreviousFlow.mWires)
		{	var wire = aPreviousFlow.mWires[i];
			wire.destroy();
		}
		for (var i in aPreviousFlow.mEndpoints)
		{	var endpoint = aPreviousFlow.mEndpoints[i];
			endpoint.onDelete();
		}
	}
	//console.profileEnd();
	
	gEndpoints=new Array();
	gWires=new Array();

	//console.profile();
	if (aFlow)
	{	
		updatePaletteOnFlowChange();

		var div=gTabs.find("#tab"+aFlow.mId);
		div.html("<table style='width: 100%; height: 100%;'><tr><td><div id='editCanvas'></div></td></tr><tr><td style='height: 45px;'></td></tr></table>");

		gEditCanvas=$( "#editCanvas" );
		gEditCanvas.droppable( {
			//hoverClass: "ui-state-active",
			accept: ".ep-proto, .ep-instance, .proto-canvas",
			drop: function( event, ui )
			{	$( this ).find( ".placeholder" ).remove();
				dropItem(event,ui,$(this));
			}
		} );
		gEditCanvas.click(deselect);
		clearValidationTasks();
		
		if (aFlow.mEndpoints)
		{	
			for (var i in aFlow.mWires)
			{	var wire = aFlow.mWires[i];
				wire.restore();
			}
		
			for (var i in aFlow.mEndpoints)
			{	var endpoint = aFlow.mEndpoints[i];
				endpoint.onRestore();
			}	
		}
		//console.profileEnd();
		
		performValidationTasks();
		gEnabledEndpointRedraw=true;
		for (var i in aFlow.mEndpoints)
		{	var endpoint = aFlow.mEndpoints[i];
			endpoint.canvasRedraw(true);
		}
	}
	else
	{	//display welcome/no scripts page
		var div=gTabs.find("#add");
		div.html("<table style='width: 100%; height: 100%;'><tr><td><div class='dummyCanvas'><span>Get started by creating a new script. Click [+] below. For click (i) above.</span></div></td></tr><tr><td style='height: 45px;'></td></tr></table>");
		gEditCanvas=null;
	}
	gEnabledEndpointRedraw=true;
	
}


//************************
// Flow class
//************************
Flow = function(aId,aDefn)
{	this.mId=aId;
	this.mDefn=aDefn;
	//console.log(aDefn);
	//this.mDefn.input=[];
	
	this.mEndpoints = new Array();
	for (var e in this.mDefn.endpoint)
	{	var epDefn = this.mDefn.endpoint[e];
		var endpoint = new Endpoint(epDefn);
		this.mEndpoints.push(endpoint);
	}
	
	this.mWires = new Array();
	for (var w in this.mDefn.wire)
	{	var wDefn = this.mDefn.wire[w];
		var startEp = this.getEndpointWithId(wDefn.se);
		var endEp = this.getEndpointWithId(wDefn.ee);
		var startC = startEp.getConnectorWithId(wDefn.sc);
		var endC=endEp.getConnectorWithId(wDefn.ec);
		var wire = new Wire(startC,endC);
		this.mWires.push(wire);
	}
}

Flow.prototype.getEndpointId = function()
{	return this.mDefn.id;
}
Flow.prototype.getName = function()
{	return this.mDefn.name;
}
Flow.prototype.getDesc = function()
{	return this.mDefn.desc;
}
Flow.prototype.isPublic = function()
{	return this.mDefn.isPublic;
}
Flow.prototype.getVerbs = function()
{	return this.mDefn.verbs;
}
Flow.prototype.getGrammar = function()
{	return this.mDefn.grammar;
}
Flow.prototype.getInputs = function()
{	return this.mDefn.input;
}

Flow.prototype.setStateFromCanvas = function()
{	var wires=new Array();
	for (var i in gWires)
	{	wires.push(gWires[i]);
	}
	var endpoints=new Array();
	for (var i in gEndpoints)
	{	endpoints.push(gEndpoints[i]);
	}
	this.mWires=wires;
	this.mEndpoints=endpoints;
}

Flow.prototype.getEndpointWithId = function(aId)
{	var result;
	for (var e in this.mEndpoints)
	{	var endpoint = this.mEndpoints[e];
		if (endpoint.mId==aId)
		{	result=endpoint;
			break;
		}
	}
	return result;
}
