Theme1 = function(){}

Theme1.prototype.LABEL_LENGTH=10;

//************************
// drawEndpoint
//************************
Theme1.prototype.drawPaletteItem = function(aCanvas,aPaletteItem)
{
	var ctx =aCanvas.get(0).getContext('2d');
	ctx.fillStyle="rgb(255,180,100)";
	ctx.translate(1,1);
	var style =aPaletteItem.mDefn.cssClass;
	this.drawEndpointShape(ctx,48,48,style,true);
	
	var that=this;
	var remaingDraw= function()
	{
		//dummy - stop text corrupting last op on firefox
		ctx.beginPath();
		ctx.closePath();
		
		var name=aPaletteItem.mDefn.name;
		that.drawLabel(ctx,name,23,3,0,"9px sans-serif");
		
	}
	
	var icon=aPaletteItem.mDefn.icon;
	if (icon)
	{	this.drawEndpointIcon(ctx,icon,48,48,remaingDraw);
	}
	else
	{	remaingDraw.apply();
	}
	
}

//************************
// drawEndpoint
//************************
Theme1.prototype.drawEndpoint = function(aCanvas,aEndpoint)
{	var resultCanvas=aCanvas;

	//endpoint title
	var title;
	if (aEndpoint.mProto)
	{	var defn=aEndpoint.mProto.mDefn;
		//if (!defn.hasValue && defn.name)
		if (defn.cssClass!="comment") title=defn.name;
	}
	else
	{	title=aEndpoint.mProtoId;
	}
	
	//bounds of endpoint box
	var bounds= [ -8, -8, aEndpoint.mWidth+8, aEndpoint.mHeight+8];
	
	//bounds of title
	if (title)
	{	var rows=splitIntoRows(title,Theme1.prototype.LABEL_LENGTH);
		var titleWidth=0;
		for (var i in rows)
		{	if (rows[i].length>titleWidth) titleWidth=rows[i].length;
		}
		titleWidth=titleWidth*9;
		var minX=(aEndpoint.mWidth-titleWidth)/2;
		var maxX=(aEndpoint.mWidth+titleWidth)/2;
		if (minX<bounds[0]) bounds[0]=minX;
		if (maxX>bounds[2]) bounds[2]=maxX;
	}
	
	//bounds of argument connector labels
	var titleWidth=0;
	for (var i in aEndpoint.mConnectors)
	{	var l=aEndpoint.mConnectors[i].mName.length;
		if (l>titleWidth) titleWidth=l;
	}
	var minX=-4-titleWidth*7;
	if (minX<bounds[0]) bounds[0]=minX;
	
	//bounds of injected connectors labels
	if (aEndpoint.mInjectedConnectors)
	{	var maxY=aEndpoint.mHeight+(aEndpoint.mInjectedConnectors.length+1)*10;
		if (maxY>bounds[3]) bounds[3]=maxY;
	}
	
	
	var x=aEndpoint.mLeft+bounds[0];
	var y=aEndpoint.mTop+bounds[1];
	var w=bounds[2]-bounds[0];
	var h=bounds[3]-bounds[1];
	resultCanvas=setCanvasRegion(aCanvas,x,y,w,h);
	var ctx =resultCanvas.get(0).getContext('2d');
	ctx.translate(-bounds[0],-bounds[1]);
	
	var enlarge=1;
	var w2=aEndpoint.mWidth;
	var h2=aEndpoint.mHeight;
		
	var style;
	if (aEndpoint.mProto)
	{	style=aEndpoint.mProto.mDefn.cssClass;
	}
	this.drawEndpointShape(ctx,w2,h2,style,aEndpoint.mValid);
	
	if (aEndpoint.mResponse)
	{	this.drawConnector(ctx,aEndpoint.mResponse);
	}
	
	for (i in aEndpoint.mConnectors)
	{	this.drawConnector(ctx,aEndpoint.mConnectors[i]);
	}
	
	for (i in aEndpoint.mInjectedConnectors)
	{	this.drawConnector(ctx,aEndpoint.mInjectedConnectors[i]);
	}
	
	//dummy - stop text corrupting last op on firefox
	ctx.beginPath();
	ctx.closePath();

	for (i in aEndpoint.mConnectors)
	{	this.drawConnectorLabel(ctx,aEndpoint.mConnectors[i]);
	}
	
	for (i in aEndpoint.mInjectedConnectors)
	{	this.drawConnectorLabel(ctx,aEndpoint.mInjectedConnectors[i]);
	}
	
	var that=this;
	var remaingDraw= function()
	{	if (title)
		{	var len=(w2/8).toFixed();
			if (len<Theme1.prototype.LABEL_LENGTH) len=Theme1.prototype.LABEL_LENGTH;
			that.drawLabel(ctx,title,w2/2,3,0,"bold 11px sans-serif",false,len);
		}
	}
	var icon;
	if (aEndpoint.mProto)
	{	icon=aEndpoint.mProto.mDefn.icon;
	}
	else
	{	icon="/tools/ncode/pub/unresolved.png";
	}
	if (icon)
	{	this.drawEndpointIcon(ctx,icon,w2,h2,remaingDraw);
	}
	else
	{	remaingDraw.apply();
	}	

	
	
	return { canvas: resultCanvas, xoffset: bounds[0], yoffset: bounds[1] };
}

//************************
// drawEndpointShape
//************************
Theme1.prototype.drawEndpointShape = function(ctx,w2,h2,style,valid)
{	//default styles
	ctx.strokeStyle="rgb(64,64,64)";
	ctx.lineWidth=1;
	ctx.shadowBlur=4;
	ctx.shadowColor="rgba(0,0,0,0.5)";
	ctx.shadowOffsetX=2;
	ctx.shadowOffsetY=2;
	
	
	if (style=="literal")
	{	//ctx.fillStyle="rgb(255,128,100)"; //pink
		ctx.fillStyle="#7c91cd"; // blue
	}
	else if (style=="argument")
	{	ctx.fillStyle="#6bc35b";
	}
	else
	{	if (!valid)
		{	ctx.fillStyle="#f83636"; 
		}
		else if (style=="ncode")
		{	ctx.fillStyle="rgb(230,230,230)";
		}
		else if (style=="response")
		{	ctx.fillStyle="rgb(128,128,128)";
		}
		else if (style=="data-source")
		{	ctx.fillStyle="#6bc35b";
		}
		else
		{	//ctx.fillStyle="rgb(255,180,100)"; //pale orange
			ctx.fillStyle="rgb(235,235,235)"; //white
			 ctx.fillStyle="#f1f0c4"; // cream
			
		}
	}
	
	if (style=="comment")
	{	this.drawComment(ctx,w2,h2);
	}
	/*
	else if (style=="response")
	{	this.drawCircle(ctx,w2,h2);
	}
	*/
	else
	{	this.drawRegularEndpoint(ctx,w2,h2);
	}
}

Theme1.prototype.drawOval = function(ctx,w,h)
{
	ctx.beginPath();
	ctx.arc(h/2, h/2, h/2, Math.PI/2, -Math.PI/2, false);
	ctx.lineTo(w-h/2,0);
	ctx.arc(w-h/2, h/2, h/2, -Math.PI/2, Math.PI/2, false);
	ctx.closePath();
	ctx.fill();
	ctx.shadowBlur=0;
	ctx.shadowColor="transparent";	
	ctx.stroke();
}

Theme1.prototype.drawComment = function(ctx,w,h)
{
	var r=20;
	ctx.beginPath();
	ctx.moveTo(0,0);
	ctx.lineTo(0,h-r);
	ctx.lineTo(r,h);
	ctx.lineTo(w,h);
	ctx.lineTo(w,0);
	ctx.closePath();
	ctx.fillStyle="rgb(255,255,255)";
	ctx.fill();
	ctx.beginPath();
	ctx.moveTo(0,h-r);
	ctx.lineTo(r,h-r);
	ctx.lineTo(r,h);
	ctx.closePath();
	ctx.shadowOffsetY=1;
	ctx.shadowOffsetX=1;
	ctx.fill();
}


Theme1.prototype.drawRegularEndpoint = function(ctx,w2,h2)
{	var r=10; //border radius
	
	roundedRect(ctx,0,0,w2,h2,r);
	ctx.fill();
	roundedRect(ctx,0,0,w2,h2,r);
	ctx.shadowBlur=0;
	ctx.shadowColor="transparent";
	ctx.stroke();
	
	var t=(w2+h2-r-r)*0.4;
	var grd=ctx.createLinearGradient(r,r,t,t);
	grd.addColorStop(0,"rgba(255,255,255,0.3)"); 
	grd.addColorStop(1,"rgba(255,255,255,0.0)");
	ctx.fillStyle=grd;
	roundedHighlightOriginal(ctx,0,0,w2,h2,r,2);
	ctx.fill();

	var grd2=ctx.createLinearGradient(w2-r,h2-r,w2-t,h2-t);
	grd2.addColorStop(0,"rgba(0,0,0,0.3)"); 
	grd2.addColorStop(1,"rgba(0,0,0,0.0)");
	ctx.fillStyle=grd2;
	roundedHighlight(ctx,0,0,w2,h2,r,true);
	ctx.fill();


}

//************************
// drawConnector
//************************
Theme1.prototype.drawConnector = function(ctx,aConnector)
{
	var x=aConnector.mLeft * aConnector.mParent.mWidth;
	var y=aConnector.mTop * aConnector.mParent.mHeight;
	
	var r=6;
	var f=2;
	

	ctx.beginPath();
	ctx.arc(x, y, r, 0, Math.PI*2, true);
	ctx.closePath();
	/*
	if ( aConnector.mRenamable )
	{
		ctx.strokeStyle="rgb(255,0,0)";
		ctx.lineWidth=6;
		ctx.stroke();
	}
	*/

	if ( aConnector.mOver)
	{	
		ctx.fillStyle="rgb(0,0,0)";
		ctx.fill();
		//console.log("filled");
	}
	else if (aConnector.mWires.length>0)
	{	
		ctx.fillStyle="rgb(64,64,64)";
		ctx.fill();
		//console.log("filled");
	}
	else 
	{	
		var grd=ctx.createRadialGradient(x+f,y+f,0,x+f,y+f,r);
		grd.addColorStop(0,"#FFFFFF"); 
		grd.addColorStop(0.5,"#FFFFFF");
		grd.addColorStop(1,"#808080");

		/*grd.addColorStop(0,"rgba(255,255,255,1)"); 
		grd.addColorStop(0.5,"rgba(255,255,255,1)");
		grd.addColorStop(1,"rgba(128,128,128,1");	*/	
		ctx.fillStyle=grd;
		ctx.fill(); 
		if (!aConnector.mOptional )  //&& false
		{
		}
		else
		{	/*
			console.log("optional");
			ctx.fillStyle="rgb(255,255,255)";
			ctx.fill();
			*/
			
			var r2=r*0.707;
			ctx.fillStyle="rgb(64,64,64)";
			ctx.beginPath();
			ctx.moveTo(x-r2,y-r2);
			ctx.lineTo(x+r2,y+r2);
			ctx.arc(x, y, r, 0, Math.PI, true);
			ctx.closePath();
			//ctx.globalCompositeOperation="source-atop";
			ctx.fill();
			//ctx.globalCompositeOperation="source-over";
		}
		
	}
	
	ctx.beginPath();
	ctx.arc(x, y, r, 0, Math.PI*2, true);
	ctx.closePath();
	ctx.lineWidth=2;
	ctx.strokeStyle="rgb(64,64,64)";
	ctx.stroke();

	ctx.lineWidth=1;
	ctx.strokeStyle="rgb(160,160,160)";
	ctx.beginPath();
	ctx.arc(x-0.5, y-0.5, r, 0, Math.PI*2, true);
	ctx.closePath();
	ctx.stroke();
	
}

Theme1.prototype.drawConnectorLabel = function(ctx,aConnector)
{
	var x=aConnector.mLeft * aConnector.mParent.mWidth;
	var y=aConnector.mTop * aConnector.mParent.mHeight;
	
	var text=aConnector.mName;
	if (aConnector.mRenamable)
	{	text=text+"*";
	}

	if (aConnector.mType==EpConnector.prototype.ARG)
	{	this.drawLabel(ctx,text,x-4,y-13,1,"9px sans-serif");
	}
	else if (aConnector.mType==EpConnector.prototype.INJECTED)
	{	var y2=y+7-(parseInt(aConnector.mIndex)+1)*9;
		this.drawLabel(ctx,text,x,y2,0,"9px sans-serif");
	}		
	
}


//************************
// drawLabel
//************************
Theme1.prototype.drawLabel = function(ctx,text,x,y,align,font,nodraw,length)
{
	var l=length;
	if (!l) l=Theme1.prototype.LABEL_LENGTH;
	var rows=splitIntoRows(text,l);
	
	ctx.font = font;
	var maxWidth=1;
	var widths = [];
	for (var i in rows)
	{	var row=rows[i];
		var w=ctx.measureText(row).width;
		widths[i]=w;
		if (w>maxWidth)
		{	maxWidth=w;
		}
	}
	
	if (!nodraw)
	{
		var rowHeight=13;
		var color="black";
		var shadowColor="rgba(255,255,255,0.75)";
	
		ctx.font = font;
		ctx.textBaseline="top";
		ctx.fillStyle = shadowColor;
		ctx.lineWidth=1;
		ctx.strokeStyle=shadowColor;
		ctx.shadowOffsetX=0.5;
		ctx.shadowOffsetY=0;
		ctx.shadowBlur=1;
		ctx.shadowColor=shadowColor; //"transparent";
		ctx.fillStyle = color;
		
		for (var i in rows)
		{	var row=rows[i];
			var offset;
			if (align==0)
			{	offset=widths[i]/2;
			}
			else if (align>0)
			{	offset=widths[i];
			}
			else
			{	offset=0;
			}
			
			ctx.strokeText(row, x-offset,y+i*rowHeight );
			ctx.shadowBlur=2;
			ctx.fillText(row, x-offset,y+i*rowHeight );
		}
	}
	
	return { w: maxWidth, h: rows.length*rowHeight };
}

//************************
// drawEndpointIcon
//************************
Theme1.prototype.drawEndpointIcon = function(ctx,icon,w,h,f)
{
	var img = new Image();
	img.src = icon;
	var f2=function()
	{	var x=((w-img.width)/2).toFixed(0);
		var y=((h-img.height)/2).toFixed(0);
		ctx.shadowBlur=0;
		ctx.shadowColor="transparent";
	   	ctx.drawImage(img, x, y);
		if (f) f.apply();
	}
	if (img.complete)
	{ f2.apply();
	}
	else
	{	img.onload = f2;
	}
}


//************************
// drawWire
//************************
Theme1.prototype.drawWire =function(aCanvas,aWire)
{
	var x1=aWire.startC.getX();
	var x2=aWire.endC.getX()-4;
	var y1=aWire.startC.getY();
	var y2=aWire.endC.getY();
	var p1 = [x1,y1];
	var p2 = [x2,y2];
	
	//distance
	var scale = Math.sqrt(Math.pow(p1[0]-p2[0],2)+Math.pow(p1[1]-p2[1],2));
	var d=100;
	scale=(1-(1/(1+(3*scale/d))))*d;

	var d1 = [aWire.startC.mDirection[0]*scale,aWire.startC.mDirection[1]*scale];
	var d2 = [aWire.endC.mDirection[0]*scale,aWire.endC.mDirection[1]*scale];
		
	var plist = [];
	//build point list to attach p1 to p2, taking into consideration terminal "directions"
	plist[0]=p1;
	plist[1] = [p1[0]+d1[0],p1[1]+d1[1]];
	plist[2] = [p2[0]+d2[0],p2[1]+d2[1]];
	plist[3]=p2;
	
	var min=[p1[0],p1[1]];
	var max=[p1[0],p1[1]];
	//find rectangle union extents
	for (var i=1; i<plist.length; i++)
	{	var p = plist[i];
		if (p[0]<min[0]) min[0]=p[0];
		if (p[1]<min[1]) min[1]=p[1];
		if (p[0]>max[0]) max[0]=p[0];
		if (p[1]>max[1]) max[1]=p[1];		
	}
	//pad region
	var padding=[10,10];
	min[0]=min[0]-padding[0];
	min[1]=min[1]-padding[1];
	max[0]=max[0]+padding[0];
	max[1]=max[1]+padding[1];

	var lw = Math.abs(max[0]-min[0]);
	var lh = Math.abs(max[1]-min[1]);	
	var result=setCanvasRegion(aCanvas,min[0],min[1],lw,lh);
	aWire.setBounds(min[0],min[1],lw,lh,plist);
	
	var plist2 = [[0,0],[0,0],[0,0],[0,0]];
	//should use a translate here, but IE doesnt seem to work right so actually re-origin the points
	for (var i=0; i<plist.length; i++) {
		plist2[i][0] = plist[i][0]-min[0];
		plist2[i][1] = plist[i][1]-min[1];
	}
	plist=plist2;

	var ctx =result.get(0).getContext('2d');
	ctx.lineWidth=3;
	
    ctx.beginPath();
	ctx.moveTo(plist[0][0],plist[0][1]);
	ctx.bezierCurveTo(
		plist[1][0],plist[1][1],
		plist[2][0],plist[2][1],
		plist[3][0],plist[3][1]);
	
	ctx.strokeStyle="rgb(255,255,255)";
	ctx.lineWidth=6;
	ctx.stroke();

	if (aWire.isPending)
	{	ctx.strokeStyle="rgb(196,196,196)";
		ctx.fillStyle=ctx.strokeStyle;
	}
	else
	{	ctx.strokeStyle="rgb(112,112,112)";
		ctx.fillStyle=ctx.strokeStyle;
	}
	ctx.lineWidth=3;
	ctx.stroke();
	
	ctx.stroke();
	
	var a=-0.15*Math.PI;
	var b=12;
	
	var v = [d2[0]*b/scale, d2[1]*b/scale];
	var p = rotate(v,a);
	ctx.beginPath();
	ctx.moveTo(plist[3][0],plist[3][1]);
	ctx.lineTo(plist[3][0]+p[0], plist[3][1]+p[1] )
	var p = rotate(v,-a);
	ctx.lineTo(plist[3][0]+p[0], plist[3][1]+p[1] )
		
	ctx.fill();
	
	return result;
	
}




//************************
// roundedHighlight
//************************
var gPI=3.14159265;

function roundedHighlight(ctx,x1,y1,w,h,r,flip)
{	ctx.save();
	if (flip)
	{	ctx.translate(x1,y1);
		ctx.translate(w/2,h/2);
		ctx.rotate(gPI);
		ctx.translate(-w/2,-h/2);
	}
	else
	{	ctx.translate(x1,y1);
	}
	ctx.beginPath();
	ctx.moveTo(r,0);
	ctx.arcTo( 0,0, 0,r, r );
	ctx.lineTo(0,h-r);
	
	var d=4; //width of edge
	ctx.bezierCurveTo(0,h-r, d,h+0, d,h-d*2);
	ctx.bezierCurveTo(d,d*2.0, d,d*2.5, d*1.8, d*1.8);
	ctx.bezierCurveTo(d*2.5,d, d*2.0,d, w-d*2, d);
	ctx.bezierCurveTo(w+0,d, w-r,0, w-r, 0);
	ctx.closePath();	
	ctx.restore();
}





function roundedHighlightOriginal(ctx,x1,y1,w,h,r,i)
{	ctx.save();
	ctx.translate(x1,y1);
	ctx.beginPath();
	ctx.moveTo(r,i);
	ctx.arcTo( i,i, i,r, r-i );
	ctx.lineTo(i,h*0.75);
	ctx.bezierCurveTo( i,h*0.9,  (i+w*0.1)/2,h*0.7, w*0.1,h*0.65 );
	ctx.bezierCurveTo( w*0.15,h*0.55, w*0.25,h*0.4, w*0.4,h*0.33 );
	ctx.bezierCurveTo( w*0.5, h*0.275, w*0.6,h*0.225, w*0.8,h*0.225);
	ctx.bezierCurveTo( w*0.95,h*0.225, w-i,h*0.225, w-i,r );
	ctx.arcTo( w-i,i, w-r,i, r-i);
	ctx.closePath();	
	ctx.restore();
}

//************************
// roundedRect
//************************
function roundedRect(ctx,x,y,w,h,r)
{	ctx.beginPath();
	ctx.moveTo(x,y+h-r);
	ctx.arcTo(x,y+h,x+r,y+h,r);
	ctx.lineTo(x+w-r,y+h);
	ctx.arcTo(x+w,y+h,x+w,y+h-r,r);
	ctx.lineTo(x+w,y+r);
	ctx.arcTo(x+w,y,x+w-r,y,r);
	ctx.lineTo(x+r,y);
	ctx.arcTo(x,y,x,y+r,r);
	ctx.closePath();
}