//************************
// removeFromArray
//************************
function removeFromArray(array, item)
{	for (var i=0; i<array.length; i++)
	{	if (array[i]==item)
		{	array.splice(i,1);
			return true;
		}
	}
	return false;
}

//************************
// insertIntoArrayAt
//************************
function insertIntoArrayAt(array, item, index)
{	array.splice(index,0,item);
}

function getConnectorPosition(index,length)
{	//return (0.5+index)/length;
	return (0.75+index)/(length+0.5);
}

//************************
// generateUniqueId
//************************
function generateUniqueId(prefix)
{	var id;
	do
	{	id = prefix + Math.floor(Math.random()*10000).toString() + Math.floor(Math.random()*10000).toString();
	} while (document.getElementById(id));
	return id;
}



//************************
// ua
//************************
ua = {
    isGecko	: /Gecko/.test(navigator.userAgent),
    isIE		: /MSIE/.test(navigator.userAgent),
    isKHTML	: /Konqueror|Safari|KHTML/.test(navigator.userAgent),
    isOpera	: /Opera/.test(navigator.userAgent),
    isSafari: /AppleWebKit/.test(navigator.appVersion)
}; 

//************************
// setCanvasRegion
//************************
setCanvasRegion = function(node,left,top,lw,lh)
{
	lw=lw.toFixed(0);
	lh=lh.toFixed(0);
	var lwp=lw+"px";
	var lhp=lh+"px";
	/*if (ua.isSafari)
	{
		var cname = node.className;
		if (!cname) cname = node.getAttribute("class");
		var node2 = document.createElement("canvas");
		node2.className=cname;
		node2.width=lw;
		node2.height=lh;
		node2.style.left=left+"px";
		node2.style.top=top+"px";
		node2.style.width=lw+"px";
		node2.style.height=lh+"px";
		//copy event listeners across
		var lners = YAHOO.util.Event.getListeners(node);
		for (var lkey in lners)
		{	var l = lners[lkey];
			YAHOO.util.Event.addListener(node2,l.type,l.fn,l.obj,l.adjust);
		}
		YAHOO.util.Event.purgeElement(node);
		node.parentNode.replaceChild(node2,node);
		return node2;
	} */
	
	//resize canvas to contain points
	rawNode=node.get(0);
	rawNode.width=lw;
	rawNode.height=lh;
	node.css("left", left);
	node.css("top", top);
	var width=node.css("width");
	var height=node.css("height");
	//console.log("no resize "+width+"="+lwp+" "+height+"="+lhp);
	if (width!=lwp || height!=lhp)
	{
		//console.log("resize "+width+"->"+lwp);
		node.css("width", lwp)
		node.css("height", lhp)
	    if (ua.isIE && rawNode.getContext)
		{	rawNode.getContext('2d').clearRect(0,0,lw,lh);
	    }
	}
	else
	{	//console.log("no resize");
		rawNode.getContext('2d').clearRect(0,0,lw,lh);
	}
    return node;
}

//************************
// rotate
//************************
function rotate(vector,angle)
{	var sin = Math.sin(angle);
	var cos = Math.cos(angle);
	return [ vector[0]*cos+vector[1]*sin, -vector[0]*sin+vector[1]*cos ];
}


//************************
// tabbedTextArea
//************************
function tabbedTextArea(aTextarea)
{
	aTextarea.bind('keydown',
    function(e){
      pressedKey = e.keyCode || -1;
      //pressedKey = e.charCode || e.keyCode || -1;
      if (pressedKey == 9) {
        if (window.event) {
          window.event.cancelBubble = true;
          window.event.returnValue = false;
        } else {
          e.preventDefault();
          e.stopPropagation();
        }

        // save current scroll position for later restoration
        var oldScrollTop=this.scrollTop;

        if (this.createTextRange) {
          document.selection.createRange().text="\t";
          this.onblur = function() { this.focus(); this.onblur = null; };
        } else if (this.setSelectionRange) {
          start = this.selectionStart;
          end = this.selectionEnd;
          this.value = this.value.substring(0, start) + "\t" + this.value.substr(end);
          this.setSelectionRange(start + 1, start + 1);
          this.focus();
        }

        this.scrollTop=oldScrollTop;

        return false;
      }
    }
  );	
}

//************************
// AsyncInOrder
//************************
AsyncInOrder = function(functions)
{	this.mFunctions=functions;
	this.mArguments=[];
}

AsyncInOrder.prototype.getProxy = function(index)
{	var delegate = this.mFunctions[index];
	var that=this;
	var proxy = function()
	{	var inOrder=true;
		for (var i=0; i<index; i++)
		{	if (!that.mArguments[i])
			{	inOrder=false;
				break;
			}
		}
		if (inOrder)
		{	that.mArguments[index]=true;
			delegate.apply(null,arguments);
			//see if there are any we can execute now
			for (var i=index+1; i<that.mArguments.length; i++)
			{	var args=that.mArguments[i];
				if (args && args!=true)
				{	that.mArguments[i]=true;
					that.mFunctions[i].apply(null,args);
				}
			}	
		}
		else
		{	that.mArguments[index]=arguments;
		}
	}
	return proxy;
}

//************************
// splitIntoRows
//************************
var gSplitIntoRowsRegex=/([\w\:\*]+)/g;
splitIntoRows = function(aText, aMaxLength)
{
	var a;
	var result=[];
	var sb="";
	while (a=gSplitIntoRowsRegex.exec(aText))
	{	var part=a[0];
		if (part.length+sb.length+1<=aMaxLength)
		{	if (sb.length>0)
			{	sb=sb+" "+part;
			}
			else
			{	sb=part;
			}
		}
		else if (sb.length==0)
		{	sb=part;
		}
		else
		{	result.push(sb);
			sb=part;
		}
	}
	if (sb.length>0)
	{	result.push(sb);
	}
	return result;
}