WIRE_COLOUR="#707070";
WIRE_PENDING_COLOUR="#D0D0D0"

Wire = function(startConnector, endConnector)
{
	var id = generateUniqueId("w");
	var n = $("<canvas class='wire' id='"+id+"'/>");
	this.root=n;
	this.startC=startConnector;
	this.endC=endConnector;
	
	//this.innerInit();
	/*
	// dynamic google canvas initialisation
	if (typeof(G_vmlCanvasManager)!="undefined")
	{	editCanvas.appendChild(n);
		G_vmlCanvasManager.initElement(n);
		this.root = document.getElementById(id);
		editCanvas.removeChild(this.root); 
		
		this.clickCatcher = document.createElement('div');
		this.clickCatcher.className='clickCatcher';
		editCanvas.insertBefore(this.clickCatcher,editCanvas.firstChild);
		YAHOO.util.Event.addListener(this.clickCatcher, "click", this.click, this );
		
		editCanvas.insertBefore(this.root,editCanvas.firstChild);
		
	}
	else
	{	this.root = n;
		n.appendTo(gEditCanvas);
	}
	*/

	
}

Wire.prototype.innerInit = function()
{	this.isPending=false;
	this.root.appendTo(gEditCanvas);
	gWires.push(this);
	this.root.click(this.onClick);
	/*
	if (this.startC.isOrphaned())
	{	console.log("orphaned start");
		this.startC=this.startC.getReplacement();
	}
	*/
	if (this.endC.isOrphaned())
	{	console.log("orphaned end");
		this.endC=this.endC.getReplacement();
	}
	
	this.startC.addWire(this);
	this.endC.addWire(this);
	this.update();	
}

Wire.prototype.restore = function()
{	this.innerInit();
	if (this.endC.mParent)
	{	this.endC.mParent.onUpdatedInputs();
	}
	if (this.startC.mParent)
	{	this.startC.mParent.onUpdatedOutputs();
	}
}

Wire.prototype.destroy = function()
{	if (this.clickCatcher)
	{	editCanvas.removeChild(this.clickCatcher);
	}
	removeFromArray(gWires,this);
	this.root.detach();
	this.startC.removeWire(this);
	this.endC.removeWire(this);
	if (this.endC.mParent)
	{	this.endC.mParent.onUpdatedInputs();
	}
	if (this.startC.mParent)
	{	this.startC.mParent.onUpdatedOutputs();
	}
}

Wire.prototype.onClick = function(e)
{	var p=gEditCanvas.offset();
	var x=e.pageX-p.left;
	var y=e.pageY-p.top;
	var wire = Wire.prototype.findWire(x,y);
	if (wire)
	{	e.stopPropagation();
		wire.select();
	}
	else
	{	return true;
	}
}

Wire.prototype.select = function()
{	var p=this.getDeleteButtonPosition();
	showDeleteButton(this, p[0]-7,p[1]-7);	
}

Wire.prototype.deselect = function()
{	
}

Wire.prototype.onDeleteButton = function()
{	if (gSelected == this) 
	{	deselect();
	}
	var action = new DeleteWireAction(this);
	doAction(action);
}


Wire.prototype.setPending = function(aPending)
{	this.isPending=aPending;
	this.update();
}

Wire.prototype.update = function()
{	this.root=gTheme.drawWire(this.root,this);
}

Wire.prototype.setBounds = function(x,y,w,h,plist)
{	this.x=x;
	this.y=y;
	this.w=w;
	this.h=h;
	this.plist=plist;
}


Wire.prototype.findWire = function(x,y)
{
	var tolerance = 5.0;
	//if (this.getDistanceFrom(x,y)<tolerance)
	//{	return this;
	//}
	for (w in gWires)
	{
		var wire = gWires[w];
		if (wire.isPointInside(x,y))
		{	var d=wire.getDistanceFrom(x,y);
			if (d<tolerance)
			{	return wire;
			}
		}
	}
}

Wire.prototype.getDistanceFrom = function(x,y)
{
	var t0=0.5;	 //start in middle
	var r=0.25; // divide region into 4
	var s=0.33; // narrow into a third on each iteration
	
	var q = this.plist;
	var cx = 3*(q[1][0]-q[0][0]);
	var bx = 3*(q[2][0]-q[1][0])-cx;
	var ax = q[3][0]-q[0][0]-bx-cx;
	var x0 = q[0][0];
	var cy = 3*(q[1][1]-q[0][1]);
	var by = 3*(q[2][1]-q[1][1])-cy;
	var ay = q[3][1]-q[0][1]-by-cy;
	var y0 = q[0][1];
	
	for (var i=0; i<4; i++)
	{
		var d2min=1000000;
		var tmin=0.5;
		var t = t0-r-r;
		for (var n=0; n<4; n++)
		{	var t2=t*t;
			var t3=t*t2;
			var px=ax*t3+bx*t2+cx*t+x0;
			var py=ay*t3+by*t2+cy*t+y0;
			var dx=x-px;
			var dy=y-py;
			var d2 = dx*dx+dy*dy;
			
			if (d2<d2min)
			{	d2min=d2;
				tmin=t;
			}
			t+=r;
		}
		t0=tmin;
		r=r*s;
	}
	return Math.sqrt(d2min);
}

Wire.prototype.getDeleteButtonPosition = function()
{
	var q = this.plist;
	var cx = 3*(q[1][0]-q[0][0]);
	var bx = 3*(q[2][0]-q[1][0])-cx;
	var ax = q[3][0]-q[0][0]-bx-cx;
	var x0 = q[0][0];
	var cy = 3*(q[1][1]-q[0][1]);
	var by = 3*(q[2][1]-q[1][1])-cy;
	var ay = q[3][1]-q[0][1]-by-cy;
	var y0 = q[0][1];	
	
	var t=0.5;	
	var t2=t*t;
	var t3=t*t2;
	var px=ax*t3+bx*t2+cx*t+x0;
	var py=ay*t3+by*t2+cy*t+y0;
	
	//return [ this.x+this.root.width*0.5, this.y+this.root.height*0.5 ];
	return [ px, py];
}

Wire.prototype.isPointInside = function(x,y)
{	//console.log(this.x+" "+this.y+" "+this.root.width+" "+this.root.height);
	return (x>=this.x && x<(this.x+this.w) && y>=this.y && y<(this.y+this.h));
}

Wire.prototype.getState = function()
{
	var state= { };
	state.se = this.startC.mParent.mId;
	state.sc = this.startC.mIndex;
	state.ee = this.endC.mParent.mId;
	state.ec = this.endC.mIndex;
	return state;
}
